javascript:
	/* Watermark ID: CB70-8426-1753-66-15-4 */

	var WAXJS = {};
	WAXJS.detectedLoginForms = [];
	WAXJS.analyzedForms = [];
	WAXJS.analyzedIFrames = [];
	WAXJS.FormType = {LoginForm : 1, RegistrationForm : 2, Identity : 3, CreditCard : 4};
	WAXJS.FieldType = {UserName : 1,Password : 2};
	WAXJS.IdscActionResult = {RESULT_SUCCESS : 'SUCCESS', RESULT_FAILED : 'FAILED', RESULT_NO_ACTION : 'NOACTION'};
	WAXJS.IdscErrorCodes = {VAULT_IS_NOT_OPEN: 1, GET_LOGINS_ERROR: 2, SAVE_LOGINS_ERROR : 3, INVALID_INPUT : 4, BAD_TOKEN : 5};
	WAXJS.LoginFormTypes = {NormalLoginForm: 1, SingleFieldForm: 2, MultipleTextFieldForm: 3, MultiplePasswordForm: 4};
	WAXJS.FormElementTypes = ['text','email','number','tel','url','password','search','radio','checkbox'];
	WAXJS.FormElementSubmitTypes = ['submit'];
	WAXJS.TextElementTypes = ['text', 'email', 'number','tel','url','textarea'];
	WAXJS.PassElementTypes = ['password'];
	
	WAXJS.MonthNames = ['','january','february','march','april','may','june','july','august','september','october','november','december'];

	WAXJS.IdentityFieldTypes = {EmailAddress: 1, AddressLine1: 2, AddressLine1Phonetic: 3, AddressLine2: 4, AddressLine2Phonetic: 5, 
								AddressLine3: 6, Apartment: 7, City: 8, CityPhonetic: 9, Province: 10, State: 11, Country: 12, 
								PostalCode: 13,	PhoneHome: 14, PhoneWork: 15, PhoneMobile: 16, Country: 17, Title: 18, FirstName: 19, 
								LastName: 20, LastName2: 21, MiddleName: 22, FirstNamePhonetic: 23, LastNamePhonetic: 24, 
								FirstNameRoman: 25,	LastNameRoman: 26, BirthDate: 27, Gender: 28, Prefecture: 29, CityPhonetic: 30,
								FullDobField:31, DobDayField:32, DobMonthField:33, DobYearField:34, FullName:35, FullAddress: 36,
								Gender: 37, UserName:38, Age:39};
							
	WAXJS.IdentityGroupFieldTypes = {'FullName':1, 'Birthday': 2, 'FullAddress':3, 'HomePhone':4, 'MobilePhone':5, 
										'WorkPhone':6, 'GenericPhone':7};
	WAXJS.GenericGroupTypes = {'DateGroup':1, 'FullNameGroup':2, 'PhoneGroup': 3};
	WAXJS.GenderType = {'Male':1, 'Female': 2, 'Other': 3};
	
WAXJS.Main = (function() {
    function init(token) {
    	WAXJS.Events.subscribe('Events/FillableFormsFound', WAXJS.FormAnalyzer.processFillableForms);
        WAXJS.Events.subscribe('Events/LoginFormsFound', WAXJS.FormAnalyzer.processLoginForms);
		WAXJS.Events.subscribe('Events/FillLoginForm', WAXJS.FormFiller.fillLoginForm);
		WAXJS.Events.subscribe('Events/AttachLoginFormSubmitHandler', WAXJS.FormCaptureModule.attachLoginFormSubmitHandler);
		
		WAXJS.Events.subscribe('Events/IdentityFormsFound', WAXJS.FormAnalyzer.processIdentityForms);
		WAXJS.Events.subscribe('Events/FillIdentityForm', WAXJS.FormFiller.fillIdentityForms);
		WAXJS.Events.subscribe('Events/AttachIdentityFormFocusHandler', WAXJS.FormCaptureModule.attachFormFocusHandler);
		
		WAXJS.secToken = token;
		WAXJS.Util.populateWebPageData();
        WAXJS.FormAnalyzer.locateFillableForms(true);
    }
    
    return {init: init}
})();


/* Form analyzer module */
WAXJS.FormAnalyzer = (function() {
    function locateFillableForms(watchDocument) { 
    	var forms, fillableForms = [], frameDocument;
        
        /* Inspect all the forms in the document */
    	try{
	        forms = Array.prototype.slice.call(document.querySelectorAll('form'));
	        for (var i = 0; i<forms.length; i++) {
	        	findFillableForm(forms[i], fillableForms, document);
	        }
    	}catch(e){
    		WaxInterface.reportException('Finding Forms-'+e.message, WAXJS.webPageData);
    	}
    	
		/* If the page contains frameset, check for forms in every frame of frameset */
    	try{
			var frames = Array.prototype.slice.call(document.querySelectorAll('frame'));
			for(var i=0; i<frames.length; i++){
				frameDocument = null;
				try{
					if(WAXJS.Util.isFrameAccessible(frames[i])){
						frameDocument = frames[i].contentWindow.document;
					}
				}catch(e){}
				
				if(!frameDocument){
					continue;
				}
				
				if(frameDocument.readyState != 'complete'){
					continue;
				}
				
				forms = Array.prototype.slice.call(frameDocument.querySelectorAll('form'));
				for(var j=0; j<forms.length; j++){
					findFillableForm(forms[j], fillableForms, frameDocument);
				}
			}
    	}catch(e){
    		WaxInterface.reportException('Finding Forms inside Frames-'+e.message, WAXJS.webPageData);
    	}
			
        /* Inspect all IFrames for login forms */
    	try{
	        var iframes = Array.prototype.slice.call(document.querySelectorAll('iframe'));
	        for(var i=0; i<iframes.length; i++){
				WAXJS.analyzedIFrames.push(iframes[i]);
				frameDocument = null;
				try{
					if(WAXJS.Util.isFrameAccessible(iframes[i])){
						frameDocument = iframes[i].contentWindow.document;
					}
				}catch(e){}
				
	        	if(!frameDocument){
					continue;
				}
	        	
	        	if(frameDocument.readyState != 'complete'){
					continue;
				}
	        	
	        	forms = Array.prototype.slice.call(frameDocument.querySelectorAll('form'));
	        	for (var j = 0; j<forms.length; j++) {
	            	findFillableForm(forms[j], fillableForms, frameDocument);
	            }
	        }
    	}catch(e){
    		WaxInterface.reportException('Finding Forms inside IFrames-'+e.message, WAXJS.webPageData);
    	}
		
		/* Inspect all input fields in the document, if there is no form element found*/
    	try{
    		/* adding fillableForms.length == 0 to prevent miss on input elements becuase of delayed load time 
    		   this window.dummyFormElement is created even before the page is loaded (eg: statefarm login page) */
    		if(!window.dummyFormElement || fillableForms.length == 0){
				var inputElements = Array.prototype.slice.call(document.querySelectorAll('input, select, textarea'));
				if(window.dummyFormElement) {
					if(window.dummyFormElement.inputLength == inputElements.length) {
						/** Empty the input if the dummy variable has already seen the input elements.*/
						inputElements = [];
					}
				}
				
				if(inputElements.length > 0) {
					/*There are input elements in the document without any form element*/
					var dummyFormElement = document.createElement('form');
					findFillableForm(dummyFormElement, fillableForms, document, inputElements);
					findSubmitForDummyElement(dummyFormElement, fillableForms, inputElements);
					window.dummyFormElement = dummyFormElement;
					window.dummyFormElement.inputLength = inputElements.length;
				}
			}
    	}catch(e){
    		WaxInterface.reportException('Finding inputs inside whole body-'+e.message, WAXJS.webPageData);
    	}
        
		if(fillableForms.length){
			WAXJS.Events.publish('Events/FillableFormsFound',fillableForms);
		}
		
        if(watchDocument){
	        try{
	        	WAXJS.DocumentWatcher.watchDocument();
	        }catch(e){
	    		WaxInterface.reportException('Watch documents-'+e.message, WAXJS.webPageData);
	    	}
        }
    }
    
    /**
    * Find submit element through all the input elements and stores it so that submit handler can be attached. 
    */
    function findSubmitForDummyElement(dummyFormElement, fillableForms, inputElements) {
    	var submitButtons = dummyFormElement.querySelectorAll('input[type=submit], button[type=submit]');
		if(submitButtons.length === 0 && dummyFormElement) {
			/*check the input elements if any with submit: */
			for(var i=0; i<inputElements.length; i++){
				if(WAXJS.Util.isSubmitElement(inputElements[i])){
					if(fillableForms.length == 1) {
						fillableForms[0].submitElements = [];
						fillableForms[0].submitElements.push(inputElements[i]);
						break;
					}
				}
	     	}
		}
    }
    
    /**
     * This method will inspect whether the form is a valid fillable form
     */
    function findFillableForm(htmlForm, fillableForms, documentElement, inputElements) {
    	/* No need to analyze already analyzed forms */
    	if(WAXJS.Util.isFormAnalyzed(htmlForm)){
			return;
		}
    	
    	var formElement = {};
    	var containerElement;
    	formElement.htmlElement = htmlForm;
		formElement.documentElement = documentElement;
		
        try{
        	containerElement = findInvisibleContainerElement(formElement.htmlElement);
        }catch(e){
    		WaxInterface.reportException('findInvisibleContainerElement-'+e.message, WAXJS.webPageData);
    	}
        
        if(!containerElement){
        	/* Adding to the list of analyzed forms */
    		WAXJS.analyzedForms.push(formElement);
        }
		
        /* Finding all the valid input elements of the form */
		try{
			findAllValidInputElements(formElement, inputElements);
		}catch(e){
    		WaxInterface.reportException('findAllValidInputElements-'+e.message, WAXJS.webPageData);
    	}
        
        if(formElement.inputElements.length == 0){
        	/* No valid input element */
        	return;
        }
        
        /* Classify input elements into text elements, password elements and other elements */
        try{
        	classifyInputElements(formElement);
        	if(formElement.textElements.length + formElement.passElements.length 
            		+ formElement.selectElements.length + formElement.radioElements.length==0){
            	return;
            }
        	fillableForms.push(formElement);
        }catch(e){
    		WaxInterface.reportException('classifyInputElements-'+e.message, WAXJS.webPageData);
    	}
    }
    
    
    /**
     * This method will find all the valid input form elements
     */
    function findAllValidInputElements(formElement, inputs){
    	var computedStyle, dims, inputElement;
    	if(!inputs){
			inputs = Array.prototype.slice.call(formElement.htmlElement.querySelectorAll('input, select, textarea'));
		}
		
    	formElement.inputElements=[];
		for(var i=0; i<inputs.length; i++){
    		if(WAXJS.Util.isFillableElement(inputs[i])){
				inputElement = {};
				inputElement.htmlElement = inputs[i];
				formElement.inputElements.push(inputElement);
			}
     	}
    }
    
    /**
     * This method will classify all the input elements into three groups
     * viz. text elements, password elements and other elements
     * 
     * @param formElement
     * @returns
     */
    function classifyInputElements(formElement){
    	formElement.textElements = [], formElement.passElements = [], formElement.selectElements = [];
    	formElement.radioElements = [], formElement.otherElements = [];
    	var inputElement;
		
		for(var i=0; i<formElement.inputElements.length; i++){
			inputElement = formElement.inputElements[i];
			if(inputElement.htmlElement.tagName.toLowerCase()=='select'){
				formElement.selectElements.push(inputElement);
			} else if(inputElement.htmlElement.tagName.toLowerCase()=='input'
				&& (inputElement.htmlElement.type.toLowerCase()=='radio'
					|| inputElement.htmlElement.type.toLowerCase()=='checkbox')){
				formElement.radioElements.push(inputElement);
			} else if(WAXJS.PassElementTypes.indexOf(inputElement.htmlElement.type.toLowerCase())>=0){
    			formElement.passElements.push(inputElement);
    		} else if(WAXJS.TextElementTypes.indexOf(inputElement.htmlElement.type.toLowerCase())>=0){
    			formElement.textElements.push(inputElement);
    		} else{
    			formElement.otherElements.push(inputElement);
    		}
    	}
		
		formElement.fillableElementCount = formElement.textElements.length + formElement.passElements.length +
										formElement.selectElements.length + formElement.radioElements.length;
    }
    
    
	/**
	 * This method will process each fillable form and decide
	 * what to do
	 */
	function processFillableForms(fillableForms){
		/* Finding login forms */
		var loginForms;
		
		try{
			loginForms = findLoginForms(fillableForms);
		}catch(e){
    		WaxInterface.reportException('findLoginForms-'+e.message, WAXJS.webPageData);
    	}
		
        if(loginForms && loginForms.length){
        	WAXJS.Events.publish('Events/LoginFormsFound',loginForms);
        } else {
        	try{
	        	if(fillableForms && fillableForms.length){
	        		for(var i=0; i<fillableForms.length; i++){
	        			if(fillableForms[i].inputElements.length <= 3){
	        				/* telemetry update */
	        				WaxInterface.updateFailedLoginFill();
	        				break;
	        			}
	        		}
	        	}
        	}catch(e){}
        }
		
        /* Remove the forms identified as login forms */
        for(var i=0; i<loginForms.length; i++){
        	for(var j=0; j<fillableForms.length; j++){
        		if(loginForms[i].htmlElement.isEqualNode(fillableForms[j].htmlElement)){
        			fillableForms.splice(j,1);
        			break;
        		}
        	}
        }
        
		/* Finding Identity forms */
        var identityForms;
        try{
        	identityForms = findIdentityForms(fillableForms);
        }catch(e){
    		WaxInterface.reportException('findIdentityForms-'+e.message, WAXJS.webPageData);
    	}
        
        if(identityForms && identityForms.length){
        	WAXJS.Events.publish('Events/IdentityFormsFound', identityForms);
        } else {
        	try{
	        	if(fillableForms && fillableForms.length){
	        		for(var i=0; i<fillableForms.length; i++){
	        			if(fillableForms[i].inputElements.length > 3){
	        				/* telemetry update */
	        				WaxInterface.updateFailedAddressFill();
	        				break;
	        			}
	        		}
	        	}
        	}catch(e){}
        }
	}
	
    
    /**
     * This function will find the login form from the list
     * of fillable forms, if any
     * 
     * @param fillableForms
     * @returns
     */
    function findLoginForms(fillableForms){
		var loginForms = [], found=false, remainingForms=[];
		
		try{
	    	for(var i=0; i<fillableForms.length; i++){
	        	/* Check whether the form is a common login form */
	        	found = checkForCommonLoginForm(fillableForms[i]);
	        	if(found){
	        		loginForms.push(fillableForms[i]);
	        	} else {
					remainingForms.push(fillableForms[i]);
				}
				
			}
		}catch(e){
    		WaxInterface.reportException('checkForCommonLoginForm-'+e.message, WAXJS.webPageData);
    	}
		
		try{
			for(var i=0; i<remainingForms.length; i++){
				/* If the form has a single password field, check for any text field near to it */
				found = checkForLoginFormUsingProximity(remainingForms[i]);
				if(found){
	        		loginForms.push(remainingForms[i]);
					remainingForms.splice(i,1);
					i--;
	        	}
			}
		}catch(e){
    		WaxInterface.reportException('checkForLoginFormUsingProximity-'+e.message, WAXJS.webPageData);
    	}
		
		try{
			for(var i=0; i<remainingForms.length; i++){
				/* If the form has a single password field, check for any text fields in the ancestor containers */
				found = checkForLoginFormUsingAncestors(remainingForms[i]);
				if(found){
	        		loginForms.push(remainingForms[i]);
					remainingForms.splice(i,1);
					i--;
	        	}
			}
		}catch(e){
    		WaxInterface.reportException('checkForLoginFormUsingAncestors-'+e.message, WAXJS.webPageData);
    	}
		
		try{
			for(var i=0; i<remainingForms.length; i++){
				/* If the form has atleast one userid field and atleast one password field */
				found = checkForMultipleTextFieldMultiplePasswordField(remainingForms[i]);
				if(found){
	        		loginForms.push(remainingForms[i]);
					remainingForms.splice(i,1);
					i--;
	        	}
			}
		}catch(e){
    		WaxInterface.reportException('checkForMultipleTextFieldMultiplePasswordField-'+e.message, WAXJS.webPageData);
    	}
		
		try{
			for(var i=0; i<remainingForms.length; i++){
				/* Check whether the form is a multipage login type */
	    		found = checkForMultiPageLoginForm(remainingForms[i]);
	    		if(found){
	    			loginForms.push(remainingForms[i]);
					remainingForms.splice(i,1);
					i--;
	        	}
	        }
		}catch(e){
    		WaxInterface.reportException('checkForMultiPageLoginForm-'+e.message, WAXJS.webPageData);
    	}
    	
    	return loginForms;
    }
    
	
	/**
	 *  This function will check for a normal login form using the proximity method 
	 */
	function checkForLoginFormUsingProximity(formElement){
		var passElement, textElement, passDims, textDims, vspace, hspace, found=false;
		if(formElement.fillableElementCount > 3){
			return;
		} else if(formElement.passElements.length!=1 || formElement.textElements.length <= 2){
			return;
		}
		
		passElement = formElement.passElements[0];
		passDims = passElement.htmlElement.getClientRects();
		
		for(var i=0; i<formElement.textElements.length; i++){
			textElement = formElement.textElements[i];
			textDims = textElement.htmlElement.getClientRects();
			
			vspace = passDims[0].top - textDims[0].bottom;
			hspace = passDims[0].left - textDims[0].right;
			
			if((vspace>0 && vspace<=20) || (hspace>0 && hspace<=20)){
				formElement.formType = WAXJS.FormType.LoginForm;
				formElement.loginFormType = WAXJS.LoginFormTypes.NormalLoginForm;
				formElement.passwordElement = passElement;
				formElement.userNameElement = textElement;
				found = true;
				break;
			}
		}
		
		if(found) {
			if(formElement.passwordElement && formElement.passwordElement.htmlElement.type == "text"){
				checkForHiddenPasswordField(formElement);
			}
			
			return true;
		}
		return false;
	}
	
	
	/*
	 * This method will check for user-id field by searching all ancestors
	 * of the password element
	*/
	function checkForLoginFormUsingAncestors(formElement){
		var count=0, ancestor, textElements, found=false;
		
		if(formElement.fillableElementCount > 3){
			return;
		} else if(formElement.passElements.length!=1){
			return;
		}
		
		ancestor = formElement.passElements[0].htmlElement;
		while(true){
			if(!ancestor.parentNode){
				break;
			}
			ancestor = ancestor.parentNode;
			count++;
			
			if(!ancestor || count>=5)break;
			textElements = ancestor.querySelectorAll('input[type=text],input[type=email],input[type=number],input[type=tel],input[type=url]');
			if(!textElements || !textElements.length){
				continue;
			}
			for(var i=0; i<textElements.length; i++){
				if(WAXJS.Util.isFillableElement(textElements[i])){
					var textElement={};
					textElement.htmlElement=textElements[i];
					findElementTokens(textElement);
					
					if(WAXJS.Util.isUserIdField(textElement)){
						formElement.textElements.push(textElement);
						formElement.userNameElement = textElement;
						formElement.passwordElement = formElement.passElements[0];
						formElement.formType = WAXJS.FormType.LoginForm;
						formElement.loginFormType = WAXJS.LoginFormTypes.NormalLoginForm;
						found=true;
						break;
					}
				}
			}
			
			if(found) {
				if(formElement.passwordElement && formElement.passwordElement.htmlElement.type == "text"){
					checkForHiddenPasswordField(formElement);
				}
				
				return true;
			}
		}
		
		return false;
	}
	
	
	function checkForMultipleTextFieldMultiplePasswordField(formElement){
		if(formElement.textElements.length + formElement.passElements.length > 3){
			return;
		}
		
		var userNameElement, passwordElement, tokens, token;
		
		if(formElement.textElements && formElement.textElements.length){
			for(var i=0; i<formElement.textElements.length; i++){
				findElementTokens(formElement.textElements[i]);
				if(!userNameElement && WAXJS.Util.isUserIdField(formElement.textElements[i])){
					userNameElement = formElement.textElements[i];
				} else if(!passwordElement && WAXJS.Util.isPasswordField(formElement.textElements[i])){
					passwordElement = formElement.textElements[i];
				}
			}
		}
		
		if(formElement.passElements && formElement.passElements.length){
			for(var i=0; i<formElement.passElements.length; i++){
				findElementTokens(formElement.passElements[i]);
				tokens = formElement.passElements[i].labelTokens;
				if(!tokens || !tokens.length){
					continue;
				}
				for(var j=0; j<tokens.length; j++){
					token = tokens[j];
					if(WAXJS.Util.isUserIdField2(token)){
						userNameElement = formElement.passElements[i];
						break;
					} else if(WAXJS.Util.isPasswordField2(token)){
						passwordElement = formElement.passElements[i];
						break;
					}
				}
			}
		}
		
		if(userNameElement || passwordElement){
			formElement.userNameElement = userNameElement;
			formElement.passwordElement = passwordElement;
			formElement.formType = WAXJS.FormType.LoginForm;
			formElement.loginFormType = WAXJS.LoginFormTypes.MultiplePasswordForm;
			
			if(formElement.passwordElement && formElement.passwordElement.htmlElement.type == "text"){
				checkForHiddenPasswordField(formElement);
			}
			
			return true;
		}
		return false;
	}
	
    
    /**
     * This function will check for multipage login types
     * If the form contains only one userid field or only one
     * password field 
     * 
     * @param formElement
     * @returns
     */
    function checkForMultiPageLoginForm(formElement){
    	if((formElement.textElements.length + formElement.passElements.length) != 1){
    		return;
    	}
		var matchingTokens=0, found=false;
		
		if(formElement.textElements && formElement.textElements.length){
			findElementTokens(formElement.textElements[0]);
			if(WAXJS.Util.isUserIdField(formElement.textElements[0])){
				/* This is the userid of multipage login */
				formElement.formType = WAXJS.FormType.LoginForm;
				formElement.loginFormType = WAXJS.LoginFormTypes.SingleFieldForm;
				formElement.userNameElement = formElement.textElements[0];
				found=true;
				
				if(formElement.passwordElement && formElement.passwordElement.htmlElement.type == "text"){
					checkForHiddenPasswordField(formElement);
				}
			}
		}else if(formElement.passElements && formElement.passElements.length){
			findElementTokens(formElement.passElements[0]);
			if(WAXJS.Util.isPasswordField(formElement.passElements[0])){
				/* This is the password of multipage login */
				formElement.formType = WAXJS.FormType.LoginForm;
				formElement.loginFormType = WAXJS.LoginFormTypes.SingleFieldForm;
				formElement.passwordElement = formElement.passElements[0];
				found=true;
				
				if(formElement.passwordElement && formElement.passwordElement.htmlElement.type == "text"){
					checkForHiddenPasswordField(formElement);
				}
			}
		}
		
		return found;
    }
    
    
    /**
     * This method will check whether the form is a login form
     * TODO: In case of multiple userid fields or password fields
     * need to add some detection logic to select the most appropriate field
     * 
     * @param formElement
     * @returns
     */
    function checkForCommonLoginForm(formElement){
		var found=false;
    	if(formElement.textElements.length==1 && formElement.passElements.length==1){
    		formElement.loginFormType = WAXJS.LoginFormTypes.NormalLoginForm;
    		formElement.userNameElement = formElement.textElements[0];
    		formElement.passwordElement = formElement.passElements[0];
    	}
    	
    	if(formElement.loginFormType){
    		formElement.formType = WAXJS.FormType.LoginForm;
			found=true;
			
			if(formElement.passwordElement && formElement.passwordElement.htmlElement.type == "text"){
				checkForHiddenPasswordField(formElement);
			}
    	}
		
		return found;
    }
    
    
	function checkForHiddenPasswordField(formElement){
		var siblingElement;
		var displayStyleValue;
		if(formElement.passwordElement.htmlElement.type != "text"){
			return;
		}
		
		/* searching forward */
		siblingElement = formElement.passwordElement.htmlElement;
		while(true){
			siblingElement = siblingElement.nextSibling;
			if(!siblingElement){
				break;
			}
			
			if(siblingElement.type == "password" && siblingElement.style && siblingElement.style.display == "none"){
				displayStyleValue = formElement.passwordElement.htmlElement.style.display;
				formElement.passwordElement.htmlElement.style.display = siblingElement.style.display;
				siblingElement.style.display = displayStyleValue;
				
				formElement.passwordElement.htmlElement = siblingElement;
				return;
			}
		}
		
		/* searching backwards */
		siblingElement = formElement.passwordElement.htmlElement;
		while(true){
			siblingElement = siblingElement.previousSibling;
			if(!siblingElement){
				break;
			}
			
			if(siblingElement.type == "password" && siblingElement.style && siblingElement.style.display == "none"){
				displayStyleValue = formElement.passwordElement.htmlElement.style.display;
				formElement.passwordElement.htmlElement.style.display = siblingElement.style.display;
				siblingElement.style.display = displayStyleValue;
				
				formElement.passwordElement.htmlElement = siblingElement;
				return;
			}
		}
	}
	
	
    /**
     * This function will find the identity fields in the form
     */
    function findIdentityForms(fillableForms){
    	var fillableForm, textElement, passwordElement, selectElement, radioElement,identityForms=[], elementGroup;
		var inputElement;
    	for(var i=0; i<fillableForms.length; i++){
    		fillableForm = fillableForms[i];
			fillableForm.elementGroups = [];
    		
    		if(fillableForm.textElements && fillableForm.textElements.length){
    			for(var j=0; j<fillableForm.textElements.length; j++){
    				textElement = fillableForm.textElements[j];
    				try{
    					findElementLabelTokens1(textElement);
    				}catch(e){
    		    		WaxInterface.reportException('findElementLabelTokens1-TextElements-'+e.message, WAXJS.webPageData);
    		    	}
					
					if(textElement.labelTokens.length==0){
						/* unable to find a token specific to this element */
						/* This element could be part of a group */
						
						if(!textElement.belongsToElementGroup){
							/* element is not part of any group. So try to find a new group */
							try{
								findElementLabelTokensForGroup(textElement, fillableForm);
							}catch(e){
		    		    		WaxInterface.reportException('findElementLabelTokensForGroup-TextElements-'+e.message, WAXJS.webPageData);
		    		    	}
						}
					}
    			}
    		}
    		
    		if(fillableForm.passElements && fillableForm.passElements.length){
    			for(var j=0; j<fillableForm.passElements.length; j++){
    				passwordElement = fillableForm.passElements[j];
    				try{
    					findElementLabelTokens1(passwordElement);
    				}catch(e){
    		    		WaxInterface.reportException('findElementLabelTokens1-PassElements-'+e.message, WAXJS.webPageData);
    		    	}
    				
					if(passwordElement.labelTokens.length==0){
						/* unable to find a token specific to this element */
						/* This element could be part of a group */
						
						if(!passwordElement.belongsToElementGroup){
							/* element is not part of any group. So try to find a new group */
							try{
								findElementLabelTokensForGroup(passwordElement, fillableForm);
							}catch(e){
		    		    		WaxInterface.reportException('findElementLabelTokensForGroup-PassElements-'+e.message, WAXJS.webPageData);
		    		    	}
						}
					}
    			}
    		}
    		
    		if(fillableForm.selectElements && fillableForm.selectElements.length){
    			for(var j=0; j<fillableForm.selectElements.length; j++){
    				selectElement = fillableForm.selectElements[j];
    				try{
    					findElementLabelTokens1(selectElement);
    				}catch(e){
    		    		WaxInterface.reportException('findElementLabelTokens1-SelectElements-'+e.message, WAXJS.webPageData);
    		    	}

    				if(selectElement.labelTokens.length==0){
						/* unable to find a token specific to this element */
						/* This element could be part of a group */
						
						if(!selectElement.belongsToElementGroup){
							/* element is not part of any group. So try to find a new group */
							try{
								findElementLabelTokensForGroup(selectElement, fillableForm);
							}catch(e){
		    		    		WaxInterface.reportException('findElementLabelTokensForGroup-SelectElements-'+e.message, WAXJS.webPageData);
		    		    	}
						}
					}
    			}
    		}
    		
    		if(fillableForm.radioElements && fillableForm.radioElements.length){
    			for(var j=0; j<fillableForm.radioElements.length; j++){
    				radioElement = fillableForm.radioElements[j];
    				try{
    					findElementLabelTokens1(radioElement);
    				}catch(e){
    		    		WaxInterface.reportException('findElementLabelTokens1-RadioElements-'+e.message, WAXJS.webPageData);
    		    	}
					
    				if(radioElement.labelTokens.length==0){
						/* unable to find a token specific to this element */
						/* This element could be part of a group */
						
						if(!radioElement.belongsToElementGroup){
							/* element is not part of any group. So try to find a new group */
							try{
								findElementLabelTokensForGroup(radioElement, fillableForm);
							}catch(e){
		    		    		WaxInterface.reportException('findElementLabelTokensForGroup-RadioElements-'+e.message, WAXJS.webPageData);
		    		    	}
						}
					}
    			}
    		}
    		
			/* Now try to identify individual fields */
    		try{
    			checkForIndividualIdentityFields(fillableForm);
    		}catch(e){
	    		WaxInterface.reportException('checkForIndividualIdentityFields-'+e.message, WAXJS.webPageData);
	    	}
			
			/* If we are not able to identify any individual field using its tokens */
			/* we may be able to identify it as part of a group. Try to find out a group label */
			var possibleGroup;
			try{
				for(var j=0; j<fillableForm.textElements.length; j++){
					textElement = fillableForm.textElements[j];
					if(!textElement.fieldType && !textElement.belongsToElementGroup
						&& (possibleGroup=WAXJS.Util.getPossibleGroup(textElement))){
						findElementLabelTokensForGroup(textElement, fillableForm, possibleGroup);
					}
				}
				
				for(var j=0; j<fillableForm.radioElements.length; j++){
					radioElement = fillableForm.radioElements[j];
					if(!radioElement.fieldType && !radioElement.belongsToElementGroup
						&& (possibleGroup=WAXJS.Util.getPossibleGroup(radioElement))){
						findElementLabelTokensForGroup(radioElement, fillableForm, possibleGroup);
					}
				}
				
				for(var j=0; j<fillableForm.selectElements.length; j++){
					selectElement = fillableForm.selectElements[j];
					if(!selectElement.fieldType && !selectElement.belongsToElementGroup
						&& (possibleGroup=WAXJS.Util.getPossibleGroup(selectElement))){
						findElementLabelTokensForGroup(selectElement, fillableForm, possibleGroup);
					}
				}
			}catch(e){
	    		WaxInterface.reportException('findElementLabelTokensForGroup-possibleGroup-'+e.message, WAXJS.webPageData);
	    	}
			
			/* try to identify various group fields */
			try{
				checkForGroupIdentityFields(fillableForm);
			}catch(e){
	    		WaxInterface.reportException('checkForGroupIdentityFields-'+e.message, WAXJS.webPageData);
	    	}
    		
			var identifiedGroupCount=0;
			for(var j=0; j<fillableForm.elementGroups.length; j++){
				if(fillableForm.elementGroups[j].groupType 
					|| (fillableForm.elementGroups[j].groupFields
						&& fillableForm.elementGroups[j].groupFields.length)){
							identifiedGroupCount++;
						}
			}
			
    		if(fillableForm.identityElements.length || identifiedGroupCount>0){
    			identityForms.push(fillableForm);
    		}
    	}
    	
    	return identityForms;
    }
    
    /* This function will try to identify various group identity fields */
	function checkForGroupIdentityFields(fillableForm){
		/* There could be two kinds of groups. 1. A group label identifying the whole group */
		/* individual fields may or may not have tokens to identify them within the group */
		/* Few example are FullName, Birthday (with 3 fields), PhoneNumber (with 2,3,4) fields */
		/* 2. One or more individual field labels can be combined together to a single label */
		/* Few examples are City/Zip, FirstName/LastName, Country/ZipCode etc */
		
		var elementGroup, tokens;
		for(var i=0; i<fillableForm.elementGroups.length; i++){
			elementGroup = fillableForm.elementGroups[i];
			
			/* Try to identify first kind of group. To identify first kind of group, we use the group field tokens */
			/* These kind of groups is predefined. Currently we check for FullName, Birthday, FullAddress, */
			/* Gender, HomePhone, MobilePhone, WorkPhone, Title(Salutation) with options as radio buttons, */
			tokens = elementGroup.tokens.slice(0); /* clone the array */
			
			for(var j=0; j<elementGroup.elements.length; j++){
				tokens = WAXJS.Util.concatArrays(tokens, elementGroup.elements[j].labelTokens);
			}
			
			for(var j=0; j<tokens.length; j++){
				if(WAXJS.Util.isFullNameField(tokens[j])){
					elementGroup.groupType = WAXJS.IdentityGroupFieldTypes.FullName;
					break;
				} else if(WAXJS.Util.isBirthdayField(tokens[j])){
					elementGroup.groupType = WAXJS.IdentityGroupFieldTypes.Birthday;
					break;
				} else if(WAXJS.Util.isFullAddressField(tokens[j])){
					elementGroup.groupType = WAXJS.IdentityGroupFieldTypes.FullAddress;
					break;
				} else if(WAXJS.Util.isHomePhoneField(tokens[j])){
					elementGroup.groupType = WAXJS.IdentityGroupFieldTypes.HomePhone;
					break;
				} else if(WAXJS.Util.isMobilePhoneField(tokens[j])){
					elementGroup.groupType = WAXJS.IdentityGroupFieldTypes.MobilePhone;
					break;
				} else if(WAXJS.Util.isWorkPhoneField(tokens[j])){
					elementGroup.groupType = WAXJS.IdentityGroupFieldTypes.WorkPhone;
					break;
				} else if(WAXJS.Util.isGenericPhoneField(tokens[j])){
					elementGroup.groupType = WAXJS.IdentityGroupFieldTypes.GenericPhone;
					break;
				}
			}
			
			if(elementGroup.groupType){
				/* group already identified */
				continue;
			}
			
			/* Try to identify the second kind of group. If group label contains, one or more */
			/* individual field labels, then it will be considered as a group. Iterate through */
			/* each of the individual field tokens and check whether it is contained inside the */
			/* group label */
			var index=-1, phoneFieldFound;
			elementGroup.groupFields = [];
			for(var j=0; j<tokens.length; j++){
				phoneFieldFound=false;
				if((index=WAXJS.Util.isFirstNameField(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.FirstName,'index':index});
				}
				if((index=WAXJS.Util.isLastNameField(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.LastName,'index':index});
				}
				if((index=WAXJS.Util.isMiddleNameField(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.MiddleName,'index':index});
				}
				if((index=WAXJS.Util.isCityNameField(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.City,'index':index});
				}
				if((index=WAXJS.Util.isStateNameField(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.State,'index':index});
				}
				if((index=WAXJS.Util.isZipCodeField(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.PostalCode,'index':index});
				}
				if((index=WAXJS.Util.isEmailAddressField(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.EmailAddress,'index':index});
				}
				if((index=WAXJS.Util.isAddressLine1Field(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.AddressLine1,'index':index});
				}
				if((index=WAXJS.Util.isAddressLine2Field(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.AddressLine2,'index':index});
				}
				if((index=WAXJS.Util.isAddressLine3Field(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.AddressLine3,'index':index});
				}
				if((index=WAXJS.Util.isCountryNameField(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.Country,'index':index});
				}
				if((index=WAXJS.Util.isHomePhoneField(tokens[j], true))>=0){
					phoneFieldFound = true;
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.PhoneHome,'index':index});
				}
				if((index=WAXJS.Util.isMobilePhoneField(tokens[j], true))>=0){
					phoneFieldFound = true;
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.PhoneMobile,'index':index});
				}
				if((index=WAXJS.Util.isWorkPhoneField(tokens[j], true))>=0){
					phoneFieldFound = true;
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.PhoneWork,'index':index});
				}
				if(!phoneFieldFound && (index=WAXJS.Util.isGenericPhoneField(tokens[j], true))>=0){
					elementGroup.groupFields.push({'fieldType':WAXJS.IdentityFieldTypes.PhoneHome,'index':index});
				}
			}
			
			
		}
	}
	
	
	/* This function will identify individual identity fields */
    function checkForIndividualIdentityFields(fillableForm){
    	var textElement, selectElement, radioElement, dateFieldType, tokens;
    	fillableForm.identityElements = [];
    	var dateElements=[];
    	
    	if(fillableForm.textElements && fillableForm.textElements.length){
	    	for(var i=0; i<fillableForm.textElements.length; i++){
	    		textElement = fillableForm.textElements[i];
				if(textElement.belongsToElementGroup){
					continue;
				}
				
	    		/* tokens = WAXJS.Util.concatArrays(textElement.labelTokens, textElement.attributeTokens); */
	    		tokens = textElement.labelTokens;
	    		
	    		for(var j=0; j<tokens.length; j++){
	    			if(WAXJS.Util.isFullNameField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.FullName;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isFirstNameField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.FirstName;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isLastNameField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.LastName;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isMiddleNameField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.MiddleName;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		}  else if(WAXJS.Util.isUserNameField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.UserName;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isEmailAddressField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.EmailAddress;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isAddressLine1Field(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.AddressLine1;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isAddressLine2Field(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.AddressLine2;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isAddressLine3Field(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.AddressLine3;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isFullAddressField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.FullAddress;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isCityNameField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.City;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isStateNameField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.State;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isCountryNameField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.Country;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isZipCodeField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.PostalCode;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isHomePhoneField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.PhoneHome;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isMobilePhoneField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.PhoneMobile;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isWorkPhoneField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.PhoneWork;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} else if(WAXJS.Util.isBirthdayField(tokens[j])){
						textElement.fieldType = WAXJS.IdentityFieldTypes.FullDobField;
		    			fillableForm.identityElements.push(textElement);
		    			break;
		    		} 
	    		}
	    	}
    	}
    	
    	if(fillableForm.selectElements && fillableForm.selectElements.length){
    		for(var i=0; i<fillableForm.selectElements.length; i++){
    			selectElement = fillableForm.selectElements[i];
				if(selectElement.belongsToElementGroup){
					continue;
				}
				
				if(WAXJS.Util.isCountryNameField2(selectElement.htmlElement)){
					selectElement.fieldType = WAXJS.IdentityFieldTypes.Country;
		    		fillableForm.identityElements.push(selectElement);
					continue;
				}
				
    			tokens = WAXJS.Util.concatArrays(selectElement.labelTokens, selectElement.attributeTokens);
    			
    			for(var j=0; j<tokens.length; j++){
	    			if(WAXJS.Util.isStateNameField(tokens[j])){
						selectElement.fieldType = WAXJS.IdentityFieldTypes.State;
		    			fillableForm.identityElements.push(selectElement);
		    			break;
		    		} else if(WAXJS.Util.isCountryNameField(tokens[j])){
						selectElement.fieldType = WAXJS.IdentityFieldTypes.Country;
		    			fillableForm.identityElements.push(selectElement);
		    			break;
		    		} else if(WAXJS.Util.isGenderField(tokens[j])){
						selectElement.fieldType = WAXJS.IdentityFieldTypes.Gender;
		    			fillableForm.identityElements.push(selectElement);
		    			break;
		    		} else if(WAXJS.Util.isTitleField(tokens[j])){
						selectElement.fieldType = WAXJS.IdentityFieldTypes.Title;
		    			fillableForm.identityElements.push(selectElement);
		    			break;
					}
    			}
    		}
    	}
    	
    	
    	if(fillableForm.radioElements && fillableForm.radioElements.length){
    		for(var i=0; i<fillableForm.radioElements.length; i++){
    			radioElement = fillableForm.radioElements[i];
				if(radioElement.belongsToElementGroup){
					continue;
				}
				
    			tokens = WAXJS.Util.concatArrays(radioElement.labelTokens, radioElement.attributeTokens);
    			
    			for(var j=0; j<tokens.length; j++){
	    			if(WAXJS.Util.isGenderField(tokens[j])){
						radioElement.fieldType = WAXJS.IdentityFieldTypes.Gender;
		    			fillableForm.identityElements.push(radioElement);
		    			break;
		    		} else if(WAXJS.Util.isTitleField(tokens[j])){
						radioElement.fieldType = WAXJS.IdentityFieldTypes.Title;
		    			fillableForm.identityElements.push(radioElement);
		    			break;
					}
    			}
    		}
    	}
    }
    
    
    /**
     * This function will get all the tokens related to the 
     * input element.
     * 
     * @param inputElement
     * @returns
     */
    function findElementTokens(inputElement, fillableForm){
    	findElementLabelTokens1(inputElement);
    	findElementAttributeTokens(inputElement);
    }
    
    /* This function will find the tokens which belongs only to this element */
    function findElementLabelTokens1(inputElement, skipCleanup){
    	if(!inputElement)return;
    	var prevSibling=inputElement.htmlElement, nodeText;
    	var tagTextContainer=['div','li','td','label','p','font','a','em','b','center','span','article','nav','header','section','aside','dt','dd','dl','legend'];
    	var tagOuterContainer=['table','tr','th','ul','ol','fieldset'], containsOtherElements=false;
    	var inputElementsInsideNode;
    	inputElement.labelTokens = [];
    	
    	while(true){
    		nodeText='';
    		
    		if(inputElement.htmlElement.tagName.toLowerCase()=='input' 
				&& (inputElement.htmlElement.type.toLowerCase()=='radio'
					|| inputElement.htmlElement.type.toLowerCase()=='checkbox')){
	    		if(prevSibling.nextSibling){
	    			prevSibling = prevSibling.nextSibling;
	    		} else if(prevSibling.parentNode){
	    			prevSibling = prevSibling.parentNode;
	    		}else {
					break;
				}
    		} else {
    			if(prevSibling.previousSibling){
	    			prevSibling = prevSibling.previousSibling;
	    		}else if(prevSibling.parentNode){
	    			prevSibling = prevSibling.parentNode;
	    		}else {
					break;
				}
    		}
			
    		if(!WAXJS.Util.isVisible(prevSibling)){
    			continue;
    		}
    		
    		if(prevSibling.nodeType==1){
    			if(prevSibling.tagName.toLowerCase()=='form' || prevSibling.tagName.toLowerCase()=='body'){
    				break;
    			} else if(prevSibling.tagName.toLowerCase()=='input' 
							|| prevSibling.tagName.toLowerCase()=='select'
							|| prevSibling.tagName.toLowerCase()=='textarea'){
    				inputElementsInsideNode = [prevSibling];
    			} else {
    				inputElementsInsideNode = prevSibling.querySelectorAll('input:not([type="hidden"]), select, textarea');
    			}
				if(inputElementsInsideNode && inputElementsInsideNode.length>1){
					break;
				}
				if(inputElementsInsideNode && inputElementsInsideNode.length==1){
					if(!inputElementsInsideNode[0].isEqualNode(inputElement.htmlElement)){
						break;
					}
				}
			}
			
    		if(prevSibling.nodeType==3){
    			nodeText = prevSibling.nodeValue;
    		}else if(prevSibling.nodeType==1 && prevSibling.tagName){
    			if(tagTextContainer.indexOf(prevSibling.tagName.toLowerCase())>=0){
    				nodeText = prevSibling.innerText;
    			}else if(tagOuterContainer.indexOf(prevSibling.tagName.toLowerCase())>=0){
    				nodeText = prevSibling.innerText;
    			}
    		}
    		
			nodeText = WAXJS.Util.cleanupToken(nodeText);
    		if(nodeText && nodeText.trim()!=''){
    			inputElement.labelTokens.push(nodeText);
    		}
    	}
    	
    	/* Finding the placeholder text, if the element is a text element */
		if(inputElement.htmlElement.tagName.toLowerCase()=='input' 
			&& (WAXJS.TextElementTypes.indexOf(inputElement.htmlElement.type.toLowerCase())>=0
				|| WAXJS.PassElementTypes.indexOf(inputElement.htmlElement.type.toLowerCase())>=0)){
			var itr=0, parentElement = inputElement.htmlElement;
			while(itr<2){
				itr++;
				if(!parentElement.parentNode){
					break;
				}
				parentElement = parentElement.parentNode;
				if(!parentElement.children || !parentElement.children.length){
					continue;
				}
				for(var i=0; i<parentElement.children.length; i++){
					if(WAXJS.Util.isVisible(parentElement.children[i]) 
							&& WAXJS.Util.isElementInside(inputElement.htmlElement, parentElement.children[i])){
						nodeText = parentElement.children[i].innerText;
						if(nodeText && nodeText.trim()!=''){
							inputElement.labelTokens.push(nodeText);
						}
					}
				}
			}
			
			if(inputElement.htmlElement.placeholder && inputElement.htmlElement.placeholder != ""){
				inputElement.labelTokens.push(inputElement.htmlElement.placeholder);
			}
		} else if(inputElement.htmlElement.tagName.toLowerCase()=='select'){
			/* For select elements, the default selected option value or the first option value */
			/* will be considered as the placeholder text */
			var options = inputElement.htmlElement.options;
			var selIndex = inputElement.htmlElement.selectedIndex;
			if(options && options.length){
				if(inputElement.htmlElement.selectedIndex > -1 && selIndex < options.length){
					if(options[selIndex].text.trim() != ''){
						inputElement.labelTokens.push(options[selIndex].text);
					}
				} else {
					if(options[0].text.trim() != ''){
						inputElement.labelTokens.push(options[selIndex].text);
					}
				}
			}
		}
    	
    	if(!skipCleanup){
    		inputElement.labelTokens = WAXJS.Util.cleanupTokens(inputElement.labelTokens);
    	}
    }
	
	
	/* This function will find the tokens which belongs only to this element */
    function findElementLabelTokensForGroup(inputElement, fillableForm, possibleGroup){
    	if(!inputElement)return;
		
    	var inputElementsInsideNode, dirtyText;
		var elementGroup, partOfExistingGroup=false;
    	var prevSibling=inputElement.htmlElement, nodeText, tagTextContainer=['div','li','td','label','p','font','a','em','b','center','span','article','nav','header','section','aside','dt','dd','dl'];
    	var tagOuterContainer=['table','tr','th','ul','ol'], containsOtherElements=false;
    	
    	while(true){
    		nodeText='';
    		
    		if(inputElement.htmlElement.tagName.toLowerCase()=='input' 
				&& (inputElement.htmlElement.type.toLowerCase()=='radio'
					|| inputElement.htmlElement.type.toLowerCase()=='checkbox')){
	    		if(prevSibling.nextSibling){
	    			prevSibling = prevSibling.nextSibling;
	    		} else if(prevSibling.parentNode){
	    			prevSibling = prevSibling.parentNode;
	    		}else {
					break;
				}
    		} else {
    			if(prevSibling.previousSibling){
	    			prevSibling = prevSibling.previousSibling;
	    		}else if(prevSibling.parentNode){
	    			prevSibling = prevSibling.parentNode;
	    		}else {
					break;
				}
    		}
			
    		if(!WAXJS.Util.isVisible(prevSibling)){
    			continue;
    		}
    		
    		if(prevSibling.nodeType==1){
    			if(prevSibling.tagName.toLowerCase()=='form' || prevSibling.tagName.toLowerCase()=='body'){
    				break;
    			} else if(prevSibling.tagName.toLowerCase()=='input' 
							|| prevSibling.tagName.toLowerCase()=='select'
							|| prevSibling.tagName.toLowerCase()=='textarea'){
    				inputElementsInsideNode = [prevSibling];
    			} else {
    				inputElementsInsideNode = prevSibling.querySelectorAll('input:not([type="hidden"]), select, textarea');
    			}
				if(inputElementsInsideNode && inputElementsInsideNode.length==1 
					&& inputElementsInsideNode[0].isEqualNode(inputElement.htmlElement)){
				
				} else if(inputElementsInsideNode && inputElementsInsideNode.length){
					if(!elementGroup){
						elementGroup = {};
						inputElement.belongsToElementGroup = true;
						inputElement.possibleGroup = possibleGroup;
						inputElement.elementGroup = elementGroup;
						elementGroup.elements = [inputElement];
						elementGroup.tokens = [];
						/* Save uncleaned tokens also. It might help to find birthday pattern */
						elementGroup.dirtyTokens = [];
					}
					var elements = Array.prototype.slice.call(inputElementsInsideNode);
					var elementExistsInGroup;
					for(var i=0; i<elements.length; i++){
						elementExistsInGroup = false;
						for(var j=0; j<elementGroup.elements.length; j++){
							if(elements[i].isEqualNode(elementGroup.elements[j].htmlElement)){
								elementExistsInGroup=true;
								break;
							}
						}
						
						if(!elementExistsInGroup){
							var wrapperElement = getElementWrapper(elements[i], fillableForm.inputElements);
							if(wrapperElement){
							
								if(wrapperElement.belongsToElementGroup){
									elementGroup = wrapperElement.elementGroup;
									inputElement.belongsToElementGroup = true;
									inputElement.elementGroup = elementGroup;
									if(WAXJS.Util.isElementOnLeft(inputElement.htmlElement, wrapperElement.htmlElement)){
										elementGroup.elements.unshift(inputElement);
									} else {
										elementGroup.elements.push(inputElement);
									}
									partOfExistingGroup=true;
									break;
								} else {
									wrapperElement.belongsToElementGroup = true;
									wrapperElement.possibleGroup = possibleGroup;
									wrapperElement.elementGroup = elementGroup;
									if(WAXJS.Util.isElementOnLeft(inputElement.htmlElement, elements[i])){
										elementGroup.elements.push(wrapperElement);
									} else {
										elementGroup.elements.unshift(wrapperElement);
									}
								}
							}
						}
					}
				}
			}
			
    		if(prevSibling.nodeType==3){
    			nodeText = prevSibling.nodeValue;
    		}else if(prevSibling.nodeType==1 && prevSibling.tagName){
    			if(tagTextContainer.indexOf(prevSibling.tagName.toLowerCase())>=0){
    				nodeText = prevSibling.innerText;
    			}else if(tagOuterContainer.indexOf(prevSibling.tagName.toLowerCase())>=0){
    				nodeText = prevSibling.innerText;
    			}
    		}
    		
    		dirtyText = nodeText.trim();
			nodeText = WAXJS.Util.cleanupToken(nodeText);
    		if(nodeText && nodeText!='' && elementGroup){
    			elementGroup.tokens.push(nodeText);
    			if(dirtyText != ''){
					elementGroup.dirtyTokens.push(dirtyText);
				}
				break;
    		}
    	}
		
		if(!partOfExistingGroup && elementGroup){
			fillableForm.elementGroups.push(elementGroup);
		}
    }
	
	/* Currently the elementGroup.elements[] array contains html nodes */
	/* Replace them with its wrapper. We are doing this because the wrapper */
	/* might contain additional data like attribute tokens, label tokens for */
	/* individual field etc. These data will help us to identify the order of */
	/* the field with in the group, at the time of form filling */
	function getElementWrapper(htmlElement, formInputElements){
		var wrapperElement;
		for(var i=0; i<formInputElements.length; i++){
			if(htmlElement.isEqualNode(formInputElements[i].htmlElement)){
				wrapperElement = formInputElements[i];
				break;
			}
		}
		return wrapperElement;
	}
	
    
    function findElementAttributeTokens(inputElement){
    	inputElement.attributeTokens = [];
    	
    	/* Collect other attributes of the element */
    	if(inputElement.htmlElement.name && inputElement.htmlElement.name != ""){
    		inputElement.attributeTokens.push(inputElement.htmlElement.name);
    	}
    	
    	if(inputElement.htmlElement.alt && inputElement.htmlElement.alt != ""){
    		inputElement.attributeTokens.push(inputElement.htmlElement.alt);
    	}
    	
    	if(inputElement.htmlElement.title && inputElement.htmlElement.title != ""){
    		inputElement.attributeTokens.push(inputElement.htmlElement.title);
    	}
    	
    	if(inputElement.htmlElement.tagName && inputElement.htmlElement.tagName.toLowerCase()=="select" 
    		&& inputElement.htmlElement.selectedIndex > -1){
    			var option = inputElement.htmlElement.options[inputElement.htmlElement.selectedIndex];
    			if(!option.value || option.value=="-1" || inputElement.htmlElement.selectedIndex==0){
    				if(option.text && option.text.trim()!=''){
    	    			inputElement.attributeTokens.push(option.text);
    	    		}
    			}
    	}
    	
    	inputElement.attributeTokens = WAXJS.Util.cleanupTokens(inputElement.attributeTokens);
    }
	
    /**
     * This method will check for a container element among form's ancestors
     * whose display is hidden
     * 
     * @param element
     * @returns
     */
    function findInvisibleContainerElement(htmlElement){
		if(!htmlElement || htmlElement.localName=='body'){
			return null;
		}
		
		var style = window.getComputedStyle(htmlElement);
		if(style.getPropertyValue('display')=='none'
			|| style.getPropertyValue('visibility') == 'hidden'){
				return htmlElement;
			}
		
		return findInvisibleContainerElement(htmlElement.parentNode);
	}
    
    
	/* This function will process login forms */
	function processLoginForms(loginForms){
		
		if(!loginForms || !loginForms.length){
			return;
		}
		
		/* Attach form submit handlers to login forms */
		WAXJS.Events.publish('Events/AttachLoginFormSubmitHandler',loginForms);
		
		/* Selecting the default login form */
		var loginForm;
		for(var i=0; i<loginForms.length; i++){
			if(loginForms[i].loginFormType == WAXJS.LoginFormTypes.NormalLoginForm){
				loginForm = loginForms[i];
				break;
			}
		}
		
		if(loginForm){
			WAXJS.Events.publish('Events/FillLoginForm', loginForm);
			return;
		}
		
		for(var i=0; i<loginForms.length; i++){
			if(loginForms[i].loginFormType == WAXJS.LoginFormTypes.MultipleTextFieldForm
					|| loginForms[i].loginFormType == WAXJS.LoginFormTypes.MultiplePasswordForm){
				loginForm = loginForms[i];
				break;
			}
		}
		
		if(loginForm){
			WAXJS.Events.publish('Events/FillLoginForm', loginForm);
			return;
		}
		
		for(var i=0; i<loginForms.length; i++){
			if(loginForms[i].loginFormType == WAXJS.LoginFormTypes.SingleFieldForm){
				loginForm = loginForms[i];
				break;
			}
		}
		
		if(loginForm){
			WAXJS.Events.publish('Events/FillLoginForm', loginForm);
			return;
		}
	}
	
	
	function processIdentityForms(identityForms){
		if(!identityForms || !identityForms.length){
			return;
		}
		
		WAXJS.identityFormsOnPage = identityForms;
		
		/* Attach form focus handlers to identity forms */
		/* WAXJS.Events.publish('Events/AttachIdentityFormFocusHandler',identityForms); */
		WAXJS.Events.publish('Events/FillIdentityForm', identityForms);
	}
	
    return {locateFillableForms: locateFillableForms,
		processFillableForms: processFillableForms,
		processLoginForms: processLoginForms,
		processIdentityForms: processIdentityForms};
})();


/**
 * This module will watch dynamically displayed forms
 * using the window.setInterval() facility
 */
WAXJS.DocumentWatcher = (function(){
	
	function watchDocument(){
		window.setInterval(elementDisplayChangeHandler,1000);
	}
	
	function elementDisplayChangeHandler(event){
		WAXJS.FormAnalyzer.locateFillableForms(false);
	}
	
	return {watchDocument: watchDocument};
})();



WAXJS.FormFiller = (function(){
	function fillLoginForm(loginForm){
		if(!loginForm){
			return;
		}
		WAXJS.currentLoginForm = loginForm;
		
		var result = WaxInterface.getSavedLogins(WAXJS.webPageData);
		if(!result){
			return;
		}
		
		/* check for any error */
		if(result.resultType == WAXJS.IdscActionResult.RESULT_FAILED){
			/* WaxInterface.displayNotification(result.idscError); */
			return;
		}
		
		fillLoginFormValues(loginForm, result);
	}
	
	
	function fillLoginFormValues(loginForm, result) {
		var login = result.idscLoginItem; 
		if(!login){
			/* empty login */
			return;
		}
		
        try {
			if(loginForm.userNameElement){
				WAXJS.Util.fillEl(loginForm.userNameElement.htmlElement,loginForm.documentElement, login.userName);
			}
			if(loginForm.passwordElement){
				WAXJS.Util.fillEl(loginForm.passwordElement.htmlElement,loginForm.documentElement, login.password);
			}
        	loginForm.filledLogin = login;
        	
        	/* Telemetry data update */
        	WaxInterface.updateSuccessfulLoginFill();
        } catch(e){
        	WaxInterface.reportException('fillLoginFormValues-'+e.message, WAXJS.webPageData);
        	return;
        }
        
        if(result.autoSubmitLogin){
        	WAXJS.autoSubmitLogin = true;
			try{
				WAXJS.AutoSubmitIntervalRef = window.setInterval(function(){
					autoSubmitLoginForm(loginForm, WAXJS.AutoSubmitIntervalRef);
				},500);
			}catch(e){
	    		WaxInterface.reportException('autoSubmitLoginForm-'+e.message, WAXJS.webPageData);
	    	}
		} else {
			WAXJS.autoSubmitLogin = false;
		}
    }
	
	
	function autoSubmitLoginForm(loginForm, intervalId){
		if(intervalId){
			window.clearInterval(intervalId);
		}
		
		/* If there are submit buttons on the form, the fisrt submit button will be clicked */
		var buttons;
		
		buttons = loginForm.htmlElement.querySelectorAll('input[type=submit]');
		if(buttons && buttons.length){
			buttons[0].click();
			return;
		}
		
		buttons = loginForm.htmlElement.querySelectorAll('button[type=submit]');
		if(buttons && buttons.length){
			buttons[0].click();
			return;
		}
		
		buttons = loginForm.htmlElement.querySelectorAll('button');
		if(buttons && buttons.length){
			buttons[0].click();
			return;
		}
		
		/* If unable to find a button, submit the form */
		loginForm.htmlElement.submit();
	}
	
	
	/**
	 * This function will fill the identified identity fields
	 */ 
	function fillIdentityForms(identityForm){
		if(!identityForm){
			return;
		}
		
		var result = WaxInterface.getSavedIdentity(WAXJS.webPageData);
		if(!result){
			return;
		}
		
		/* check for any error */
		if(result.resultType == WAXJS.IdscActionResult.RESULT_FAILED){
			return;
		}
		
		if(result.idscIdentity){
			try{
				fillAllAddressFormsOnPage(result.idscIdentity);
			}catch(e){
	    		WaxInterface.reportException('fillAllAddressFormsOnPage-'+e.message, WAXJS.webPageData);
	    	}
			return;
		}
		else{
			/* No saved identity for this page */
		}
		
	}
	
	function fillAllAddressFormsOnPage(idscIdentity){
		if(WAXJS.identityFormsOnPage && WAXJS.identityFormsOnPage.length){
			for(var i=0; i<WAXJS.identityFormsOnPage.length; i++){
				fillAddressFormValues(WAXJS.identityFormsOnPage[i], idscIdentity);
			}
		}
	}
	
	/* This function will fill the identified form fields */
	function fillAddressFormValues(identityForm, idscIdentity) {
		var elementGroup, identityElement;
		/* Try to fill the group identity fields */
		for(var i=0; i<identityForm.elementGroups.length; i++){
			elementGroup = identityForm.elementGroups[i];
			
			/* Check whether the group is of type 2 (Description of type 2 group */
			/* is explained in checkForGroupIdentityFields() function */
			if(elementGroup.groupFields && elementGroup.groupFields.length){
				/* Sort the group fields based on its position */
				elementGroup.groupFields.sort(sortElementGroupFields);
				for(var j=0; j<elementGroup.groupFields.length; j++){
					if(j<elementGroup.elements.length){
						identityElement = elementGroup.elements[j];
						identityElement.fieldType = elementGroup.groupFields[j].fieldType;
						try{
							fillIdentityElement(identityElement, idscIdentity, identityForm.documentElement);
						}catch(e){
				    		WaxInterface.reportException('fillIdentityElement-'+e.message, WAXJS.webPageData);
				    	}
					}
				}
			} else {
				/* Check whether the group is of type 1 (Description of type-1 group */
				/* is explained in checkForGroupIdentityFields() function */
				switch(elementGroup.groupType){
					case WAXJS.IdentityGroupFieldTypes.FullName:
						try{
							fillElementGroupWithFullName(elementGroup, idscIdentity, identityForm.documentElement);
						}catch(e){
				    		WaxInterface.reportException('fillElementGroupWithFullName-'+e.message, WAXJS.webPageData);
				    	}
						break;
					case WAXJS.IdentityGroupFieldTypes.FullAddress:
						try{
							fillElementGroupWithFullAddress(elementGroup, idscIdentity, identityForm.documentElement);
						}catch(e){
				    		WaxInterface.reportException('fillElementGroupWithFullAddress-'+e.message, WAXJS.webPageData);
				    	}
						break;
					case WAXJS.IdentityGroupFieldTypes.HomePhone:
					case WAXJS.IdentityGroupFieldTypes.MobilePhone:
					case WAXJS.IdentityGroupFieldTypes.WorkPhone:
						try{
							fillElementGroupWithPhone(elementGroup, idscIdentity, identityForm.documentElement);
						}catch(e){
				    		WaxInterface.reportException('fillElementGroupWithPhone-'+e.message, WAXJS.webPageData);
				    	}
						break;
					case WAXJS.IdentityGroupFieldTypes.Birthday:
						try{
							fillElementGroupWithBirthday(elementGroup, idscIdentity, identityForm.documentElement);
						}catch(e){
				    		WaxInterface.reportException('fillElementGroupWithBirthday-'+e.message, WAXJS.webPageData);
				    	}
						break;
				}
			}
		}
		
		/* Try to fill the individual identity fields */
		if(identityForm.identityElements && identityForm.identityElements.length){
			for(var i=0; i<identityForm.identityElements.length; i++){
				identityElement = identityForm.identityElements[i];
				if(!identityElement.belongsToElementGroup){
					try{
						fillIdentityElement(identityElement, idscIdentity, identityForm.documentElement);
					}catch(e){
			    		WaxInterface.reportException('fillIdentityElement-IndividualFields-'+e.message, WAXJS.webPageData);
			    	}
				}
			}
		}
		
		/* update telemetry data */
		WaxInterface.updateSuccessfulAddressFill();
    }
	
	/* This function will fill the elements of this group with different parts of fullname */
	/* in the correct order */
	function fillElementGroupWithFullName(elementGroup, idscIdentity, documentElement){
		var element, token;
		
		/* classify the group elements into text, select, radio and checkbox */
		classifyGroupElements(elementGroup);
		
		/* Before filling in the elements, the order need to be detrmined. The label tokens */
		/* that determines the order can be either as a token belong to the individual field */
		/* or it can be part of the group label itself. If we are unable to find the tokens */
		/* that determines the order, then assume a default ordering depending on the number of */
		/* elements in the group and the type of the element (For eg, if the element type is */
		/* a radio button, it can be the title) */
		
		/* radio elements in fullname group can be only title */
		for(var i=0; i<elementGroup.radioElements.length; i++){
			element = elementGroup.elements[i];
			for(var j=0; j<element.labelTokens.length; j++){
				if(WAXJS.Util.isWaxField2(element.labelTokens[j], WAXJS.LabelTokens.TITLE_IN_FULLNAME)>=0){
					element.fieldType = WAXJS.IdentityFieldTypes.Title;
					break;
				}
			}
		}
		
		/* select elements in fullname group can be only title */
		for(var i=0; i<elementGroup.selectElements.length; i++){
			element = elementGroup.elements[i];
			for(var j=0; j<element.htmlElement.options.length; j++){
				token = element.htmlElement.options[j].text;
				if(token != '' && WAXJS.Util.isWaxField2(token, WAXJS.LabelTokens.TITLE_IN_FULLNAME)>=0){
					element.fieldType = WAXJS.IdentityFieldTypes.Title;
					break;
				}
			}
		}
		
		if(elementGroup.textElements.length==1){
			elementGroup.textElements[0].fieldType = WAXJS.IdentityFieldTypes.FullName;
		} else {
			for(var i=0; i<elementGroup.textElements.length; i++){
				element = elementGroup.textElements[i];
				
				/* Check whether the element has any label token indicating the order */
				if(element.labelTokens && element.labelTokens.length){
					for(var j=0; j<element.labelTokens.length; j++){
						/* check its a firstname, last name or middle name */
						if(WAXJS.Util.isWaxField2(element.labelTokens[j], WAXJS.LabelTokens.FIRSTNAME_IN_FULLNAME)>=0){
							element.fieldType = WAXJS.IdentityFieldTypes.FirstName;
							break;
						} else if(WAXJS.Util.isWaxField2(element.labelTokens[j], WAXJS.LabelTokens.LASTNAME_IN_FULLNAME)>=0){
							element.fieldType = WAXJS.IdentityFieldTypes.LastName;
							break;
						} else if(WAXJS.Util.isWaxField2(element.labelTokens[j], WAXJS.LabelTokens.MIDDLENAME_IN_FULLNAME)>=0){
							element.fieldType = WAXJS.IdentityFieldTypes.MiddleName;
							break;
						}
					}
				}
			}
		
			/* Now try to identify the order using the group label */
			var textFieldCount=0;
			for(var i=0; i<elementGroup.textElements.length; i++){
				if(!elementGroup.textElements[i].fieldType){
					textFieldCount++;
				}
			}
		
			var fullNameFields = [], index;
			if(textFieldCount>0){
				/* Try to identify the order of fields from the group label */
				for(var i=0; i<elementGroup.tokens.length; i++){
					if((index=WAXJS.Util.isWaxField2(elementGroup.tokens[i], WAXJS.LabelTokens.FIRSTNAME_IN_FULLNAME))>=0){
						fullNameFields.push({'fieldType':WAXJS.IdentityFieldTypes.FirstName, 'index':index});
					}
					if((index=WAXJS.Util.isWaxField2(elementGroup.tokens[i], WAXJS.LabelTokens.LASTNAME_IN_FULLNAME))>=0){
						fullNameFields.push({'fieldType':WAXJS.IdentityFieldTypes.LastName, 'index':index});
					}
					if((index=WAXJS.Util.isWaxField2(elementGroup.tokens[i], WAXJS.LabelTokens.MIDDLENAME_IN_FULLNAME))>=0){
						fullNameFields.push({'fieldType':WAXJS.IdentityFieldTypes.MiddleName, 'index':index});
					}
					break; /* consider only the first token for the time being */
				}
				
				if(fullNameFields.length){
					fullNameFields.sort(sortElementGroupFields);
					for(var i=0; i<elementGroup.textElements.length; i++){
						elementGroup.textElements[i].fieldType = fullNameFields[i].fieldType;
					}
				}
			}
			
			/* Unable to identify using individual labels or group label. So apply the default ordering */
			var textFieldCount=0;
			for(var i=0; i<elementGroup.textElements.length; i++){
				if(!elementGroup.textElements[i].fieldType){
					textFieldCount++;
				}
			}
			
			if(textFieldCount>0){
				switch(elementGroup.textElements.length){
					case 2:
						elementGroup.textElements[0].fieldType = WAXJS.IdentityFieldTypes.FirstName;
						elementGroup.textElements[1].fieldType = WAXJS.IdentityFieldTypes.LastName;
						break;
					case 3:
						elementGroup.textElements[0].fieldType = WAXJS.IdentityFieldTypes.FirstName;
						elementGroup.textElements[1].fieldType = WAXJS.IdentityFieldTypes.MiddleName;
						elementGroup.textElements[2].fieldType = WAXJS.IdentityFieldTypes.LastName;
						break;
				}
			}
		}
		
		for(var i=0; i<elementGroup.elements.length; i++){
			element = elementGroup.elements[i];
			switch(element.fieldType){
				case WAXJS.IdentityFieldTypes.Title:
					WAXJS.Util.fillEl(element.htmlElement,documentElement, idscIdentity.title);
					break;
				case WAXJS.IdentityFieldTypes.FirstName:
					WAXJS.Util.fillEl(element.htmlElement,documentElement, idscIdentity.firstName);
					break;
				case WAXJS.IdentityFieldTypes.LastName:
					WAXJS.Util.fillEl(element.htmlElement,documentElement, idscIdentity.lastName);
					break;
				case WAXJS.IdentityFieldTypes.MiddleName:
					WAXJS.Util.fillEl(element.htmlElement,documentElement, idscIdentity.middleName);
					break;
				case WAXJS.IdentityFieldTypes.FullName:
					var fullName='';
					if(idscIdentity.firstName != '')
						fullName += idscIdentity.firstName + ' ';
					if(idscIdentity.middleName != '')
						fullName += idscIdentity.middleName + ' ';
					if(idscIdentity.lastName != '')
						fullName += idscIdentity.lastName + ' ';
					
					WAXJS.Util.fillEl(element.htmlElement,documentElement, fullName);
					break;
			}
		}
	}
	
	function fillElementGroupWithFullAddress(elementGroup, idscIdentity, documentElement){
	
	}
	
	function fillElementGroupWithPhone(elementGroup, idscIdentity, documentElement){
		var phoneNumber;
		
		switch(elementGroup.groupType){
			case WAXJS.IdentityGroupFieldTypes.HomePhone:
				phoneNumber = idscIdentity.phoneHome;
				break;
			case WAXJS.IdentityGroupFieldTypes.MobilePhone:
				phoneNumber = idscIdentity.phoneMobile;
				break;
			case WAXJS.IdentityGroupFieldTypes.WorkPhone:
				phoneNumber = idscIdentity.phoneWork;
				break;
		}
		
		if(!phoneNumber || phoneNumber==''){
			return;
		}
		
		/* classify elements into text, select, radio and checkbox */
		classifyGroupElements(elementGroup);
		
		switch(elementGroup.textElements.length){
			case 1:
				WAXJS.Util.fillEl(elementGroup.textElements[0].htmlElement,documentElement, phoneNumber);
				break;
			case 2:
				WAXJS.Util.fillEl(elementGroup.textElements[0].htmlElement,documentElement, idscIdentity.countryCode);
				WAXJS.Util.fillEl(elementGroup.textElements[1].htmlElement,documentElement, phoneNumber);
				break;
			case 3:
				WAXJS.Util.fillEl(elementGroup.textElements[0].htmlElement,documentElement, phoneNumber.length>=3? phoneNumber.substring(0,3):phoneNumber);
				WAXJS.Util.fillEl(elementGroup.textElements[1].htmlElement,documentElement, phoneNumber.length>=6? phoneNumber.substring(3,6):'');
				WAXJS.Util.fillEl(elementGroup.textElements[2].htmlElement,documentElement, phoneNumber.length>=10? phoneNumber.substring(6,10):'');
				break;
			case 4:
				WAXJS.Util.fillEl(elementGroup.textElements[0].htmlElement,documentElement, idscIdentity.countryCode);
				WAXJS.Util.fillEl(elementGroup.textElements[1].htmlElement,documentElement, phoneNumber.length>=3? phoneNumber.substring(0,3):phoneNumber);
				WAXJS.Util.fillEl(elementGroup.textElements[2].htmlElement,documentElement, phoneNumber.length>=6? phoneNumber.substring(3,6):'');
				WAXJS.Util.fillEl(elementGroup.textElements[3].htmlElement,documentElement, phoneNumber.length>=10? phoneNumber.substring(6,10):'');
				break;
		}
	}
	
	function fillElementGroupWithBirthday(elementGroup, idscIdentity, documentElement){
		if(!idscIdentity.birthday){
			return;
		}
	
		var element, fieldType, datePattern;
		for(var i=0; i<elementGroup.elements.length; i++){
			element = elementGroup.elements[i];
			
			if(WAXJS.Util.isMonthField(element)){
				WAXJS.Util.fillDate(element.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.DobMonthField);
			} else if(WAXJS.Util.isDayField(element)){
				WAXJS.Util.fillDate(element.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.DobDayField);
			} else if(WAXJS.Util.isYearField(element)){
				WAXJS.Util.fillDate(element.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.DobYearField);
			} else if((datePattern=WAXJS.Util.findDatePattern(elementGroup.dirtyTokens))){
				switch(datePattern.elementOrder[i]){
					case WAXJS.IdentityFieldTypes.DobDayField:
						WAXJS.Util.fillDate(element.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.DobDayField);
						break;
					case WAXJS.IdentityFieldTypes.DobMonthField:
						WAXJS.Util.fillDate(element.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.DobMonthField);
						break;
					case WAXJS.IdentityFieldTypes.DobYearField:
						WAXJS.Util.fillDate(element.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.DobYearField);
						break;
				}
			}
		}
	}
	
	function classifyGroupElements(elementGroup){
		var element;
		elementGroup.textElements = [];
		elementGroup.radioElements = [];
		elementGroup.selectElements = [];
		for(var i=0; i<elementGroup.elements.length; i++){
			element = elementGroup.elements[i];
			if(element.htmlElement.tagName.toLowerCase()=='input' 
				&& element.htmlElement.type.toLowerCase()!='radio'
				&& element.htmlElement.type.toLowerCase()!='checkbox'){
				elementGroup.textElements.push(element);
			} else if(element.htmlElement.tagName.toLowerCase()=='input' 
				&& (element.htmlElement.type.toLowerCase()=='radio'
					|| element.htmlElement.type.toLowerCase()=='checkbox')){
					elementGroup.radioElements.push(element);
			} else if(element.htmlElement.tagName.toLowerCase()=='select'){
				elementGroup.selectElements.push(element);
			}
		}
	}
	
	function fillIdentityElement(identityElement, idscIdentity, documentElement){
		switch(identityElement.fieldType){
			case WAXJS.IdentityFieldTypes.FirstName:
				WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, idscIdentity.firstName);
				break;
			case WAXJS.IdentityFieldTypes.LastName:
				WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, idscIdentity.lastName);
				break;
			case WAXJS.IdentityFieldTypes.MiddleName:
				WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, idscIdentity.middleName);
				break;
			case WAXJS.IdentityFieldTypes.Title:
				WAXJS.Util.fillTitle(identityElement, documentElement, idscIdentity.title);
				break;
			case WAXJS.IdentityFieldTypes.FullName:
				var fullName='';
				if(idscIdentity.firstName != '')
					fullName += idscIdentity.firstName + ' ';
				if(idscIdentity.middleName != '')
					fullName += idscIdentity.middleName + ' ';
				if(idscIdentity.lastName != '')
					fullName += idscIdentity.lastName + ' ';
				WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, fullName);
				break;
			case WAXJS.IdentityFieldTypes.UserName:
				var username = '';
				if(idscIdentity.firstName!='' && idscIdentity.lastName!=''){
					username = idscIdentity.firstName + '_' + idscIdentity.lastName;
				} else if(idscIdentity.firstName!=''){
					username = idscIdentity.firstName;
				} else if(idscIdentity.lastName!=''){
					username = idscIdentity.lastName;
				}
				WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, username.toLowerCase());
				break;
			case WAXJS.IdentityFieldTypes.EmailAddress:
				WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, idscIdentity.emailAddress);
				break;
			case WAXJS.IdentityFieldTypes.AddressLine1:
				WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, idscIdentity.addressLine1);
				break;
			case WAXJS.IdentityFieldTypes.AddressLine2:
				WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, idscIdentity.addressLine2);
				break;
			case WAXJS.IdentityFieldTypes.AddressLine3:
				WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, idscIdentity.addressLine3);
				break;
			case WAXJS.IdentityFieldTypes.FullAddress:
				var fullAddress = '';
				if(identityElement.htmlElement.tagName.toLowerCase()=='input'){
					fullAddress = idscIdentity.addressLine1;
					fullAddress += ' ' + idscIdentity.addressLine2;
					fullAddress += ' ' + idscIdentity.addressLine3;
					WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, fullAddress);
				} else if(identityElement.htmlElement.tagName.toLowerCase()=='textarea'){
					fullAddress = idscIdentity.addressLine1;
					fullAddress += '\n' + idscIdentity.addressLine2;
					fullAddress += '\n' + idscIdentity.addressLine3;
					WAXJS.Util.fillEl(identityElement.htmlElement,documentElement, fullAddress);
				}
				break;
			case WAXJS.IdentityFieldTypes.City:
				WAXJS.Util.fillEl(identityElement.htmlElement, documentElement, idscIdentity.city);
				break;
			case WAXJS.IdentityFieldTypes.State:
				WAXJS.Util.fillEl(identityElement.htmlElement, documentElement, idscIdentity.state);
				break;
			case WAXJS.IdentityFieldTypes.Country:
				WAXJS.Util.fillEl(identityElement.htmlElement, documentElement, idscIdentity.countryNames);
				break;
			case WAXJS.IdentityFieldTypes.PostalCode:
				WAXJS.Util.fillEl(identityElement.htmlElement, documentElement, idscIdentity.zipCode);
				break;
			case WAXJS.IdentityFieldTypes.PhoneMobile:
				WAXJS.Util.fillEl(identityElement.htmlElement, documentElement, idscIdentity.phoneMobile);
				break;
			case WAXJS.IdentityFieldTypes.PhoneWork:
				WAXJS.Util.fillEl(identityElement.htmlElement, documentElement, idscIdentity.phoneWork);
				break;
			case WAXJS.IdentityFieldTypes.PhoneHome:
				WAXJS.Util.fillEl(identityElement.htmlElement, documentElement, idscIdentity.phoneHome);
				break;
			case WAXJS.IdentityFieldTypes.Gender:
				WAXJS.Util.fillGender(identityElement, documentElement, idscIdentity.gender);
				break;	
			case WAXJS.IdentityFieldTypes.FullDobField:
				WAXJS.Util.fillDate(identityElement.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.FullDobField, identityElement.datePattern);
				break;
			case WAXJS.IdentityFieldTypes.DobDayField:
				WAXJS.Util.fillDate(identityElement.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.DobDayField);
				break;
			case WAXJS.IdentityFieldTypes.DobMonthField:
				WAXJS.Util.fillDate(identityElement.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.DobMonthField);
				break;
			case WAXJS.IdentityFieldTypes.DobYearField:
				WAXJS.Util.fillDate(identityElement.htmlElement, documentElement, idscIdentity.birthday, WAXJS.IdentityFieldTypes.DobYearField);
				break;
		}
	}
	
	/* This function will sort the group fields */
	function sortElementGroupFields(obj1, obj2){
		if(obj1 && obj2 && obj1.index>=0 && obj2.index>=0){
			return obj1.index - obj2.index;
		}
		
		/* TODO: Return default object sort result */
		return 0;
	}
	
	return {fillLoginForm: fillLoginForm,
			fillLoginFormValues: fillLoginFormValues,
			fillIdentityForms: fillIdentityForms,
			fillAddressFormValues: fillAddressFormValues,
			fillAllAddressFormsOnPage: fillAllAddressFormsOnPage};
})();


WAXJS.Heuristics = (function() {
    function isHidden(el, str) {
        var str = str || '',
            isHidden = (el.getAttribute('type') == 'hidden');
        return isHidden;
    }
    
    function isReadOnly(el, str) {
        var str = str || '';
        return (el.getAttribute('readonly') != null);
    }
    
    function isUserName(el, str) {
        var str = str || '';
        return !isHidden(el, str) && !isReadOnly(el, str) && !isPass(el, str) && (isEmail(el, str) || str.match(/.*user.*|.*login.*|.*signin.*|.*id.*/i));
    }
    
    function isPass(el, str) {
        var str = str || '';
        return !isHidden(el, str) && (el.getAttribute('type') == 'password');
    }
    
    function isEmail(el, str) {
        var str = str || '';
        return !isHidden(el, str) && str.match(/.*mail.*/i);
    }
    
    return {
        isHidden: isHidden,
        isReadOnly: isReadOnly,
        isUserName: isUserName,
        isPass: isPass,
        isEmail: isEmail
    }
})();


WAXJS.FormCaptureModule = (function(){

	/* This method will attach submit handlers to all the login forms */
	function attachLoginFormSubmitHandler(loginForms){
		for(var i=0; i<loginForms.length; i++){
			try{
				addLoginFormFieldBlurHandler(loginForms[i]);
				addFormSubmitEventListener(loginForms[i]);
			}catch(e){
	    		WaxInterface.reportException('addFormSubmitEventListener-'+e.message, WAXJS.webPageData);
	    	}
			WAXJS.detectedLoginForms.push(loginForms[i]);
		}
	}


	function addLoginFormFieldBlurHandler(loginForm){
		if(loginForm && loginForm.userNameElement && loginForm.userNameElement.htmlElement){
			var usernameParent = loginForm.userNameElement.htmlElement.parentNode;
			if(usernameParent){
				usernameParent.addEventListener('keypress', function(event){
					if(event.which == 13 && event.target.isEqualNode(loginForm.userNameElement.htmlElement)){
						loginForm.userNameElement.valueBeforeEnter = loginForm.userNameElement.htmlElement.value;
						loginForm.userNameElement.valueBeforeBlur = '';
					}
					return true;
				}, true);
				
				usernameParent.addEventListener('blur', function(event){
					if(event.target.isEqualNode(loginForm.userNameElement.htmlElement)){
						loginForm.userNameElement.valueBeforeBlur = loginForm.userNameElement.htmlElement.value;
						loginForm.userNameElement.valueBeforeEnter = '';
					}
				}, true);
			}
		}
		if(loginForm && loginForm.passwordElement && loginForm.passwordElement.htmlElement){
			var passParent = loginForm.passwordElement.htmlElement.parentNode;
			if(passParent){
				passParent.addEventListener('keypress', function(event){
					if(event.which == 13 && event.target.isEqualNode(loginForm.passwordElement.htmlElement)){
						loginForm.passwordElement.valueBeforeEnter = loginForm.passwordElement.htmlElement.value;
						loginForm.passwordElement.valueBeforeBlur = '';
					}
					return true;
				}, true);
				
				passParent.addEventListener('blur', function(event){
					if(event.target.isEqualNode(loginForm.passwordElement.htmlElement)){
						loginForm.passwordElement.valueBeforeBlur = loginForm.passwordElement.htmlElement.value;
						loginForm.passwordElement.valueBeforeEnter = '';
					}
				}, true);
			}
		}
	}
	
	
	function addFormSubmitEventListener(loginForm){
		var proto = loginForm.htmlElement.__proto__ || loginForm.form.prototype; 
		if(proto && proto.submit){
			var originalMethod = proto.submit;
			proto.submit = function(){
				try{
					if(loginForm && !loginForm.submitHandled && !loginForm.submitDispatched){
						loginForm.submitDispatched=true;
						if (this.fireEvent) {
							this.fireEvent('submit');
						} 
						else {
							var oEvent = document.createEvent('Event');
							oEvent.initEvent('submit', false, false);
							this.dispatchEvent(oEvent);
						}
					}
				}catch(e){}
				return originalMethod.apply(this, arguments);
			};
		}
		loginForm.htmlElement.addEventListener('submit', loginFormSubmitHandler);
		
		/* Ajax submission won't trigger form submit event. So if the login form */
		/* has submit buttons, listen to the click event of those buttons */
		var submitButtons = loginForm.htmlElement.querySelectorAll('input[type=submit], button[type=submit]');
		
		if(submitButtons && submitButtons.length == 0 && loginForm.submitElements){
			submitButtons = loginForm.submitElements;
		}
		
		if(submitButtons && submitButtons.length){
			for(var i=0; i<submitButtons.length; i++){
				submitButtons[i].addEventListener('click', function(event){
					loginFormSubmitHandler(event,loginForm);
				});
			}
		}
		
		/* Forms can be submitted by enter keypress. so add a key listener to password field */
		if(loginForm.passwordElement){
			loginForm.passwordElement.htmlElement.addEventListener('keydown',function(event){
				if(event.which==13){
					loginFormSubmitHandler(event,loginForm);
				}
			});
		} else if(loginForm.userNameElement){
			loginForm.userNameElement.htmlElement.addEventListener('keydown',function(event){
				if(event.which==13){
					loginFormSubmitHandler(event,loginForm);
				}
			});
		}
	}
		
		
		/**
		 * When a login form is submitted, this handler will capture the 
		 * username and password and save them to user's vault
		 */
		function loginFormSubmitHandler(event, clickedForm){
			try{
				
				var submittedForm;
				if(clickedForm){
					submittedForm = clickedForm;
				} else {				
					for(var i=0; i<WAXJS.detectedLoginForms.length; i++){
						if(WAXJS.detectedLoginForms[i].htmlElement==event.currentTarget){
							submittedForm = WAXJS.detectedLoginForms[i];
							break;
						}
					}
				}
				
				if(!submittedForm || submittedForm.submitHandled){
					return;
				}
				
				/* If the login was autosubmitted, user won't be able to change the values */
				/* If there is a change, it will be js obfuscation of userid or password */
				/* which can be safely ignored */
				if(WAXJS.autoSubmitLogin){
					submittedForm.submitHandled = true;
					return;
				}
				
				/* Currently handle only login form */
				if(submittedForm.formType!=WAXJS.FormType.LoginForm){
					return;
				}
				
				submittedForm.submitHandled = true;
				var userPassword, userUserName, loginItem, result;
				
				if(submittedForm.userNameElement && submittedForm.userNameElement.htmlElement){
					if(submittedForm.userNameElement.valueBeforeEnter){
						userUserName = submittedForm.userNameElement.valueBeforeEnter;
					} else if(submittedForm.userNameElement.valueBeforeBlur){
						userUserName = submittedForm.userNameElement.valueBeforeBlur;
					} else {
						userUserName = submittedForm.userNameElement.htmlElement.value;
					}
				}
				
				if(submittedForm.passwordElement && submittedForm.passwordElement.htmlElement){
					if(submittedForm.passwordElement.valueBeforeEnter){
						userPassword = submittedForm.passwordElement.valueBeforeEnter;
					} else if(submittedForm.passwordElement.valueBeforeBlur){
						userPassword = submittedForm.passwordElement.valueBeforeBlur;
					} else {
						userPassword = submittedForm.passwordElement.htmlElement.value;
					}
				}
				
				var saveLogin = false;
				if(submittedForm.userNameElement && submittedForm.passwordElement){
					if(userUserName && userPassword){
						saveLogin = true;
					}
				} else if(submittedForm.userNameElement){
					if(userUserName){
						saveLogin = true;
					}
				} else if(submittedForm.passwordElement){
					if(userPassword){
						saveLogin = true;
					}
				}
				
				if(!saveLogin){
					return;
				}
					
				try{
					loginItem = {};
					loginItem.userName = userUserName;
					loginItem.password = userPassword;
					loginItem.itemName = location.host;
					loginItem.url = location.href;
					loginItem.autofill = true;
					loginItem.autoSubmit = true;
					loginItem.requireVaultPassword = false;
						
					result = WaxInterface.saveLogin(loginItem, WAXJS.webPageData);
				}catch(e){
					WaxInterface.reportException('loginFormSubmitHandler - ' + e.message, WAXJS.webPageData);
				}
				
				if(!result){
					return;
				}
				
				/* No action */
				if(result.resultType == WAXJS.IdscActionResult.RESULT_NO_ACTION){
					return;
				}
				
				/* check for errors */
				if(result.resultType == WAXJS.IdscActionResult.RESULT_FAILED){
					if(result.idscError && result.idscError.errorCode && result.idscError.errorCode == WAXJS.IdscErrorCodes.VAULT_IS_NOT_OPEN){
						WaxInterface.displayNotification(result.idscError);
					} else {
						WaxInterface.displayNotification('Unable to save login');
					}
					return;
				}
				
				/* Login save success */
				if(result.resultType == WAXJS.IdscActionResult.RESULT_SUCCESS){
					WaxInterface.displayNotification(result.resultMessage);
					return;
				}
			}catch(e){
	    		WaxInterface.reportException('loginFormSubmitHandler-'+e.message, WAXJS.webPageData);
	    	}
		}
		
		
		function attachFormFocusHandler(identityForms){
			for(var i=0; i<identityForms.length; i++){
				for(var j=0; j<identityForms[i].inputElements.length; j++){
					identityForms[i].inputElements[j].htmlElement.onfocus = formInputElementFocusHandler;
				}
			}
		}
		
		function formInputElementFocusHandler(event){
			/* Identify the focused form */
			var focusedForm;
			
			for(var i=0; i<WAXJS.identityFormsOnPage.length; i++){
				for(var j=0; j<WAXJS.identityFormsOnPage[i].inputElements.length; j++){
					if(this.isEqualNode(WAXJS.identityFormsOnPage[i].inputElements[j].htmlElement)){
						focusedForm = WAXJS.identityFormsOnPage[i];
						break;
					}
				}
				
				if(focusedForm){
					WAXJS.FocusedIdentityForm = focusedForm;
					break;
				}
			}
			
			if(WAXJS.FocusedIdentityForm && !WAXJS.FocusedIdentityForm.formAlreadyFocused){
				WAXJS.FocusedIdentityForm.formAlreadyFocused = true;
				WAXJS.Events.publish('Events/FillIdentityForm', WAXJS.FocusedIdentityForm);
			}
		}

		return {addFormSubmitEventListener : addFormSubmitEventListener,
				attachLoginFormSubmitHandler: attachLoginFormSubmitHandler,
				attachFormFocusHandler: attachFormFocusHandler};
	
	})();


WAXJS.Util = (function() {
    function getUniqueKey(el) {
        var id = el.getAttribute('id') || '',
            name = el.getAttribute('name') || '',
            cls = el.getAttribute('class') || '',
            key = id + '-' + name + '-' + cls;
        return key;
    }
    
    function fillEl(element,documentElement, val) {
        if (!element || !documentElement){
            return;
        }
		WAXJS.Util.addStyle('.ids-ff-field-highlight {background: #F7C715 !important;}', documentElement);
		
		if(element.tagName.toLowerCase()=='input' || element.tagName.toLowerCase()=='textarea'){
	        element.value = val;
	        element.className += ' ' + 'ids-ff-field-highlight';
		} else if(element.tagName.toLowerCase()=='select'){
			if(element.options && element.options.length){
				if(WAXJS.Util.isArray(val)){
					for(var j=0; j<val.length; j++){
						for(var i=0; i<element.options.length; i++){
							if(element.options[i].text.toLowerCase() == val[j].toLowerCase()){
								element.selectedIndex = i;
								element.className += ' ' + 'ids-ff-field-highlight';
								return;
							}
						}
					}
				} else {
					for(var i=0; i<element.options.length; i++){
						if(element.options[i].text.toLowerCase() == val.toLowerCase()){
							element.selectedIndex = i;
							element.className += ' ' + 'ids-ff-field-highlight';
							break;
						}
					}
				}
			}
		}
    }
    
    function fillDate(element, documentElement, dateValue, type, datePattern){
    	var fieldValues=[];
    	
    	if(!datePattern){
    		datePattern = 'mm/dd/yyyy';
    	}
    	
    	if(element.tagName.toLowerCase()=='input'){
    		if(type == WAXJS.IdentityFieldTypes.FullDobField){
    			if(dateValue.day > 0){
    				datePattern = datePattern.replace('dd',''+dateValue.day);
    			}
    			if(dateValue.month > 0){
    				datePattern = datePattern.replace('mm',''+dateValue.month);
    			}
    			if(dateValue.year){
    				datePattern = datePattern.replace('yyyy',''+dateValue.year);
    				datePattern = datePattern.replace('yy',(''+dateValue.year).substring(2,2));
    			}
    			element.value = datePattern;
    			element.className += ' ' + 'ids-ff-field-highlight';
    		} else if(type == WAXJS.IdentityFieldTypes.DobDayField){
				if(dateValue.day>0){
					element.value = ''+dateValue.day;
					element.className += ' ' + 'ids-ff-field-highlight';
				}
			} else if(type == WAXJS.IdentityFieldTypes.DobMonthField){
				if(dateValue.month>0){
					element.value = ''+dateValue.month;
					element.className += ' ' + 'ids-ff-field-highlight';
				}
			} else if(type == WAXJS.IdentityFieldTypes.DobYearField){
				if(dateValue.year){
					element.value = ''+dateValue.year;
					element.className += ' ' + 'ids-ff-field-highlight';
				}
			}
    	} else if(element.tagName.toLowerCase()=='select'){
    		if(type == WAXJS.IdentityFieldTypes.DobDayField && dateValue.day>0){
    			if(element.options && element.options.length){
    				for(var i=0; i<element.options.length; i++){
    					if(parseInt(element.options[i].text)==dateValue.day){
    						element.selectedIndex = i;
    						element.className += ' ' + 'ids-ff-field-highlight';
    						break;
    					}
    				}
    			}
    		} else if(type == WAXJS.IdentityFieldTypes.DobMonthField && dateValue.month > 0){
    			fieldValues.push(WAXJS.MonthNames[dateValue.month]);
    			fieldValues.push(WAXJS.MonthNames[dateValue.month].substr(0,3));
    			if(element.options && element.options.length){
    				for(var i=0; i<element.options.length; i++){
    					if(element.options[i].text.toLowerCase().indexOf(fieldValues[0])>=0||
    							element.options[i].text.toLowerCase().indexOf(fieldValues[1])>=0||
    							element.options[i].value.toLowerCase().indexOf(fieldValues[0])>=0||
    							element.options[i].value.toLowerCase().indexOf(fieldValues[1])>=0){
    						element.selectedIndex = i;
    						element.className += ' ' + 'ids-ff-field-highlight';
    						break;
    					}
    				}
    			}
    		} else if(type == WAXJS.IdentityFieldTypes.DobYearField && dateValue.year){
    			fieldValues=[];
    			fieldValues.push(''+dateValue.year);
    			fieldValues.push(dateValue.year.toString().substr(2));
    			if(element.options && element.options.length){
    				for(var i=0; i<element.options.length; i++){
    					if(element.options[i].text.length == fieldValues[0].length
							&& element.options[i].text.toLowerCase().indexOf(fieldValues[0])>=0){
								element.selectedIndex = i;
								element.className += ' ' + 'ids-ff-field-highlight';
								break;
						} else if(element.options[i].text.length == fieldValues[1].length
							&& element.options[i].text.toLowerCase().indexOf(fieldValues[1])>=0){
								element.selectedIndex = i;
								element.className += ' ' + 'ids-ff-field-highlight';
								break;
						} else if(element.options[i].value.length == fieldValues[0].length
							&& element.options[i].value.toLowerCase().indexOf(fieldValues[0])>=0){
								element.selectedIndex = i;
								element.className += ' ' + 'ids-ff-field-highlight';
								break;
						} else if(element.options[i].value.length == fieldValues[1].length
							&& element.options[i].value.toLowerCase().indexOf(fieldValues[1])>=0){
								element.selectedIndex = i;
								element.className += ' ' + 'ids-ff-field-highlight';
								break;
						}
    				}
    			}
    		}
    	}
    }
    
    function fillGender(identityElement,documentElement,gender){
    	var tokens;
    	if(identityElement.htmlElement.tagName.toLowerCase()=='input'
    		&& (identityElement.htmlElement.type.toLowerCase()=='radio'
				|| identityElement.htmlElement.type.toLowerCase()=='checkbox')){
    		tokens = identityElement.labelTokens;
    		if(identityElement.htmlElement.value){
    			var radioValue = ''+ identityElement.htmlElement.value;
    			tokens[tokens.length] = radioValue.toLowerCase(); /* Add at last */
    		}
    		for(var i=0; i<identityElement.labelTokens.length; i++){
    			if(WAXJS.Util.isGenderFieldMale(identityElement.labelTokens[i]) && gender=='male'){
        			identityElement.htmlElement.checked=true;
        			break;
        		} else if(WAXJS.Util.isGenderFieldFemale(identityElement.labelTokens[i]) && gender=='female'){
        			identityElement.htmlElement.checked=true;
        			break;
        		}
    		}
    	} else if(identityElement.htmlElement.tagName.toLowerCase()=='select'){
    		var options = identityElement.htmlElement.options;
    		if(options.length){
    			for(var i=0; i<options.length; i++){
    				if(WAXJS.Util.isGenderFieldMale(options[i].text.toLowerCase()) && gender=='male'){
            			identityElement.htmlElement.selectedIndex = i;
            			identityElement.htmlElement.className += ' ' + 'ids-ff-field-highlight';
            			break;
            		} else if(WAXJS.Util.isGenderFieldFemale(options[i].text.toLowerCase()) && gender=='female'){
            			identityElement.htmlElement.selectedIndex = i;
            			identityElement.htmlElement.className += ' ' + 'ids-ff-field-highlight';
            			break;
            		}
    			}
    		}
    	}
    }
	
	
	function fillTitle(identityElement,documentElement,title){
    	var tokens;
    	if(identityElement.htmlElement.tagName.toLowerCase()=='input'
    		&& (identityElement.htmlElement.type.toLowerCase()=='radio'
				|| identityElement.htmlElement.type.toLowerCase()=='checkbox')){
    		tokens = identityElement.labelTokens;
    		for(var i=0; i<tokens.length; i++){
				if(title.toLowerCase() == tokens[i]){
        			identityElement.htmlElement.checked=true;
        			break;
        		}
    		}
    	} else if(identityElement.htmlElement.tagName.toLowerCase()=='select'){
    		var options = identityElement.htmlElement.options;
    		if(options.length){
    			for(var i=0; i<options.length; i++){
					if(title.toLowerCase() == options[i].text.toLowerCase()){
						identityElement.htmlElement.selectedIndex = i;
            			identityElement.htmlElement.className += ' ' + 'ids-ff-field-highlight';
            			break;
					}
    			}
    		}
    	}
    }
	
    
    function addStyle(style, documentElement) {
		try{
			var styleEl = documentElement.getElementById('ids-ff-style');
			if (!styleEl) {
				styleEl = documentElement.createElement('style');
				styleEl.type = 'text/css';
				styleEl.id = 'ids-ff-style';
				documentElement.getElementsByTagName('head')[0].appendChild(styleEl);
			}
			styleEl.appendChild(documentElement.createTextNode(style));
		}catch(e){}
    }
    
   
   function findPos(obj) {
       var curleft = curtop = 0;
       if (obj.offsetParent) {
           do {
                curleft += obj.offsetLeft;
                curtop += obj.offsetTop;
            } while (obj = obj.offsetParent);
            return {'left': curleft, 'top': curtop};
       }
   }
   
   	function isElementInside(inputElement, elementToTest){
   		if(inputElement.isEqualNode(elementToTest)){
   			return false;
   		}
   		var cr1 = inputElement.getBoundingClientRect();
   		var cr2 = elementToTest.getBoundingClientRect();
   		
   		if(cr1 && cr2 && cr1.top <= cr2.top && cr1.bottom >= cr2.bottom && cr1.left <= cr2.left && cr1.right >= cr2.right){
   			return true;
   		}
   		
   		return false;
   	}
   
	function isUserIdField(inputElement, tokenType){
		var result=false;
		
		if(!tokenType){
			result = isWaxField(WAXJS.Util.concatArrays(inputElement.labelTokens, inputElement.attributeTokens), WAXJS.LabelTokens.USERID_TOKENS);
		} else if(tokenType=='label'){
			result = isWaxField(inputElement.labelTokens, WAXJS.LabelTokens.USERID_TOKENS);
		} else if(tokenType=='attribute'){
			result = isWaxField(inputElement.attributeTokens, WAXJS.LabelTokens.USERID_TOKENS);
		}
		return result;
	}
	
	function isUserIdField2(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.USERID_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isPasswordField(inputElement, tokenType){
		var result=false;
		if(!tokenType){
			result = isWaxField(WAXJS.Util.concatArrays(inputElement.labelTokens, inputElement.attributeTokens), WAXJS.LabelTokens.PASSWORD_TOKENS);
		} else if(tokenType=='label'){
			result = isWaxField(inputElement.labelTokens, WAXJS.LabelTokens.PASSWORD_TOKENS);
		} else if(tokenType=='attribute'){
			result = isWaxField(inputElement.attributeTokens, WAXJS.LabelTokens.PASSWORD_TOKENS);
		}
		return result;

	}
	
	function isPasswordField2(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.PASSWORD_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}

	function isFirstNameField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.FIRSTNAME_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isLastNameField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.LASTNAME_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isMiddleNameField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.MIDDLENAME_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isUserNameField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.USERNAME_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isFullNameField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.FULLNAME_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isTitleField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.NAME_TITLE_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isEmailAddressField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.EMAIL_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isAddressLine1Field(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.ADDRESS_LINE1_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isAddressLine2Field(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.ADDRESS_LINE2_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isAddressLine3Field(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.ADDRESS_LINE3_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isFullAddressField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.ADDRESS_FULL_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isCityNameField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.CITY_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isStateNameField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.STATE_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isCountryNameField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.COUNTRY_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	/* If the element is a dropdown, this method will check  */
	/* whether the dropdown has country names like US, UK, etc */
	function isCountryNameField2(element){
		var countryCount=0;
		var countryName='';
		if(!element || element.tagName.toLowerCase()!='select' || !element.options || !element.options.length){
			return false;
		}
		for(var i=0; i<element.options.length; i++){
			if(element.options[i].text){
				countryName = element.options[i].text.toLowerCase();
				if(countryName.indexOf('united states')>=0 || 
					countryName.indexOf('united kingdom')>=0 ||
					countryName.indexOf('india')>=0 ||
					countryName.indexOf('canada')>=0 ||
					countryName.indexOf('russia')>=0){
					countryCount++;
					if(countryCount >= 5){
						return true;
					}
				}
			}
		}
		return false;
	}
	
	function isZipCodeField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.ZIPCODE_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isHomePhoneField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.HOME_PHONE_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isMobilePhoneField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.MOBILE_PHONE_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isWorkPhoneField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.WORK_PHONE_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isGenericPhoneField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.GENERIC_PHONE_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isGenderField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.GENDER_TOKENS);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isGenderFieldMale(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.GENDER_TOKENS_MALE);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isGenderFieldFemale(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.GENDER_TOKENS_FEMALE);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isAnyDateField(inputElement){
		var result;
		if(inputElement.htmlElement.tagName.toLowerCase()=='input'){
			result = isWaxField(WAXJS.Util.concatArrays(inputElement.labelTokens, inputElement.attributeTokens), WAXJS.LabelTokens.BIRTHDAY_WHOLE);
			if(result){
				return WAXJS.IdentityFieldTypes.FullDobField;
			}
		}
		
		result = isWaxField(WAXJS.Util.concatArrays(inputElement.labelTokens, inputElement.attributeTokens), WAXJS.LabelTokens.BIRTHDAY_DAY);
		if(result){
			return WAXJS.IdentityFieldTypes.DobDayField;
		}
		result = WAXJS.Util.isDayField(inputElement.htmlElement);
		if(result){
			return WAXJS.IdentityFieldTypes.DobDayField;
		}
		
		result = isWaxField(WAXJS.Util.concatArrays(inputElement.labelTokens, inputElement.attributeTokens), WAXJS.LabelTokens.BIRTHDAY_MONTH);
		if(result){
			return WAXJS.IdentityFieldTypes.DobMonthField;
		}
		result = WAXJS.Util.isMonthField(inputElement.htmlElement);
		if(result){
			return WAXJS.IdentityFieldTypes.DobMonthField;
		}
		
		result = isWaxField(WAXJS.Util.concatArrays(inputElement.labelTokens, inputElement.attributeTokens), WAXJS.LabelTokens.BIRTHDAY_YEAR);
		if(result){
			return WAXJS.IdentityFieldTypes.DobYearField;
		}
		result = WAXJS.Util.isYearField(inputElement.htmlElement);
		if(result){
			return WAXJS.IdentityFieldTypes.DobYearField;
		}
		
		return -1;
	}
	
	function isBirthdayField(token, retIndex){
		var index = isWaxField2(token, WAXJS.LabelTokens.BIRTHDAY_WHOLE);
		if(retIndex){
			return index;
		}
		return index >= 0;
	}
	
	function isMonthField(inputElement){
		var labelInt, onlyMonthValues=true, monthsToCheck=['jan','feb','mar','apr','may','jun','jul','aug'];
		var htmlElement = inputElement.htmlElement, token;
		
		/* If the element has any individual label token, try to identiy */
		/* using that label token */
		if(inputElement.labelTokens && inputElement.labelTokens.length){
			for(var i=0; i<inputElement.labelTokens.length; i++){
				token = inputElement.labelTokens[i];
				if(isWaxField2(token, WAXJS.LabelTokens.BIRTHDAY_MONTH)>=0){
					return true;
				}
			}
		}
		
		if(htmlElement.tagName.toLowerCase()=='select'){
			var options = htmlElement.options;
			if(options.length){
				for(var i=0; i<options.length; i++){
					for(var j=0; j<monthsToCheck.length; j++){
						if(options[i].text.toLowerCase().indexOf(monthsToCheck[j])>=0){
							monthsToCheck.splice(j,1);
							break;
						}
					}
				}
				if(monthsToCheck.length==0){
					return true;
				}
				
				for(var i=0; i<options.length; i++){
					labelInt = parseInt(options[i].text);
					if(isNaN(labelInt) || labelInt<1 || labelInt>12){
						onlyMonthValues=false;
						break;
					}
				}
				
				if(onlyMonthValues){
					return true;
				}
			}
		}
		return false;
	}
	
	function isDayField(inputElement){
		var labelInt, onlyDayValues=true;
		var htmlElement = inputElement.htmlElement, token;
		
		/* If the element has any individual label token, try to identiy */
		/* using that label token */
		if(inputElement.labelTokens && inputElement.labelTokens.length){
			for(var i=0; i<inputElement.labelTokens.length; i++){
				token = inputElement.labelTokens[i];
				if(isWaxField2(token, WAXJS.LabelTokens.BIRTHDAY_DAY)>=0){
					return true;
				}
			}
		}
		
		if(htmlElement.tagName.toLowerCase()=='select'){
			var options = htmlElement.options;
			if(options.length){
				for(var i=0; i<options.length; i++){
					if(options[i].text.trim()==''){
						continue;
					}
					labelInt = parseInt(options[i].text);
					if(isNaN(labelInt) || labelInt<1 || labelInt>31){
						onlyDayValues=false;
						break;
					}
				}
				
				if(onlyDayValues){
					return true;
				}
			}
		}
		return false;
	}
	
	function isYearField(inputElement){
		var labelInt, onlyYearValues=true, nanCount=0;
		var currentFullYear = new Date().getFullYear();
		var htmlElement = inputElement.htmlElement, token;
		
		/* If the element has any individual label token, try to identiy */
		/* using that label token */
		if(inputElement.labelTokens && inputElement.labelTokens.length){
			for(var i=0; i<inputElement.labelTokens.length; i++){
				token = inputElement.labelTokens[i];
				if(isWaxField2(token, WAXJS.LabelTokens.BIRTHDAY_YEAR)>=0){
					return true;
				}
			}
		}
		
		if(htmlElement.tagName.toLowerCase()=='select'){
			var options = htmlElement.options;
			if(options.length){
				for(var i=0; i<options.length; i++){
					if(options[i].text.trim()==''){
						continue;
					}
					labelInt = parseInt(options[i].text);
					if(isNaN(labelInt)){
						nanCount++;
					} else if(options[i].text.trim().length != 2 && options[i].text.trim().length != 4){
						onlyYearValues = false;
						break;
					}
					if(nanCount>2){
						onlyYearValues = false;
						break;
					}
					if(options[i].text.trim().length==4 && (labelInt<1900 || labelInt>currentFullYear)){
						onlyYearValues = false;
						break;
					} else if(options[i].text.trim().length==2 && (labelInt<0 || labelInt>99)){
						onlyYearValues = false;
						break;
					}
				}
				
				if(onlyYearValues){
					return true;
				}
			}
		}
		return false;
	}
	
	function isWaxField(inputElementTokens, waxFieldTokens){
		if(!waxFieldTokens || !waxFieldTokens.length){
			return false;
		}
		
		if(!inputElementTokens || !inputElementTokens.length){
			return;
		}
		
		var matchingTokens=0, token;
		
		for(var i=0; i<inputElementTokens.length; i++){
			for(var j=0; j<waxFieldTokens.length; j++){
				token = waxFieldTokens[j];
				if(token.charAt(0)=='=' && inputElementTokens[i]==token.substring(1)){
					matchingTokens++;
				} else if(inputElementTokens[i].indexOf(token)>=0){
					matchingTokens++;
				}
			}
		}
		
		if(matchingTokens>0){
			return true;
		}
		return false;
	}
	
	function isWaxField2(token, waxFieldTokens){
		var matchIndex=-1;
		if(!waxFieldTokens || !waxFieldTokens.length || !token){
			return matchIndex;
		}
		
		for(var i=0; i<waxFieldTokens.length; i++){
			if(waxFieldTokens[i].charAt(0)=='=' && token==waxFieldTokens[i].substring(1)){
				matchIndex=0;
				break;
			} else if((matchIndex=token.indexOf(waxFieldTokens[i]))>=0){
				break;
			}
		}
		
		return matchIndex;
	}
	
   
   function getUrlParts(urlString){
	   var urlParts = {};
	   tempArray = urlString.split('://');
	   if(tempArray.length<2){
		   return urlParts;
	   }
	   urlParts.protocol = tempArray[0];
	   tempArray = tempArray[1].split('/');
	   if(tempArray[0].indexOf(':')>=0){
			tempArray = tempArray[0].split(':');
			urlParts.hostname = tempArray[0];
			urlParts.port = tempArray[1];
		} else {
			urlParts.hostname = tempArray[0];
			urlParts.port = '';
		}
	   return urlParts;
   }
   
	function isFillableElement(element){
		if(element.tagName.toLowerCase()=='input' && WAXJS.FormElementTypes.indexOf(element.type.toLowerCase())<0){
			return false;
		}
		
		return isFieldsValid(element);
	}
	
	function isSubmitElement(element){
		if(element.tagName.toLowerCase()=='input' && WAXJS.FormElementSubmitTypes.indexOf(element.type.toLowerCase())<0){
			return false;
		}
		
		return isFieldsValid(element);
	}
	
	function isFieldsValid(element) {
		if(element.hasAttribute && element.hasAttribute('readonly')){
			return false;
		}
		if(element.hasAttribute && element.hasAttribute('disabled')){
			return false;
		}
		if(window.getComputedStyle){
			while(element && element.tagName.toLowerCase() != 'html'){
	    		computedStyle = window.getComputedStyle(element);
	    		if(computedStyle.getPropertyValue('display').toLowerCase()=='none'){
	    			return false;
	    		}
	    		if(computedStyle.getPropertyValue('visibility').toLowerCase()!='visible'){
	    			return false;
	    		}
				if(computedStyle.getPropertyValue('width')==0 || computedStyle.getPropertyValue('height')==0){
					return false
				}
				
				element = element.parentNode;
			}
		}
		
		return true;
	}
		
	
	function isVisible(element, windowObject){
		var style,visible=true;
		
		if(!windowObject){
			windowObject = window;
		}
		
		while(element && windowObject){
			style = windowObject.getComputedStyle(element);
			if(style && (style.getPropertyValue('display')=='none' || 
							style.getPropertyValue('visibility') == 'hidden')){
				visible=false;
				break;
			}
			element = element.parentNode;
		}
		return visible;
	}
	
	function containsNode(element, array){
		var contains=false;
		for(var i=0; i<array.length; i++){
			if(element.isEqualNode(array[i])){
				contains=true;
				break;
			}
		}
		return contains;
	}
	
	function populateWebPageData(){
		WAXJS.webPageData={};
		WAXJS.webPageData.pageUrl = window.location.href;
		WAXJS.webPageData.pageTitle = document.title;
		WAXJS.webPageData.faviconUrl = getFaviconUrl();
	}
	
	function getFaviconUrl(){
		var faviconUrl;
		var linkTags = document.querySelectorAll('link[rel="icon"], link[rel="shortcut icon"]');
		if(linkTags && linkTags.length){
			faviconUrl = linkTags[0].getAttribute('href')
		}
		
		if(faviconUrl){
			if(faviconUrl.substring(0,2)=='//'){
				faviconUrl = window.location.protocol + faviconUrl;
			} else if(faviconUrl.substring(0,1)=='/'){
				faviconUrl = window.location.protocol + '//' + window.location.host + faviconUrl;
			}
		} else {
			faviconUrl = window.location.protocol + '//' + window.location.host + '/favicon.ico';
		}
		
		return faviconUrl;
	}
	
	
	function cleanupTokens(tokens){
		var cleanTokens=[], tempArray, charRep, token;
		for(var i=0; i<tokens.length; i++){
			token = tokens[i];
			token = token.trim().toLowerCase();
			for(var j=0; j<WAXJS.LabelTokens.CHAR_REPLACEMENTS.length; j++){
				charRep = WAXJS.LabelTokens.CHAR_REPLACEMENTS[j];
				for(var k=0; k<charRep.chars.length; k++){
					token = token.replace(charRep.chars[k],charRep.rep);
				}
			}
			token = token.replace(/[\s\.:\-_\*\?#@&%^$!"'=<>\/\\;,\+\)\(]/g,'');
			if(token){
				cleanTokens.push(token);
			}
		}
		return cleanTokens;
	}
	
	function cleanupToken(token){
		var charRep;
		token = token.trim().toLowerCase();
		for(var i=0; i<WAXJS.LabelTokens.CHAR_REPLACEMENTS.length; i++){
			charRep = WAXJS.LabelTokens.CHAR_REPLACEMENTS[i];
			for(var j=0; j<charRep.chars.length; j++){
				token = token.replace(charRep.chars[j],charRep.rep);
			}
		}
		token = token.replace(/[\s\.:\-_\*\?#@&%^$!"'=<>\/\\;,\+\)\(]/g,'');
		return token;
	}
	
	function concatArrays(arr1, arr2, arr3, arr4, arr5){
		var result=[];
		if(arr1){
			result = result.concat(arr1);
		}
		if(arr2){
			result = result.concat(arr2);
		}
		if(arr3){
			result = result.concat(arr3);
		}
		if(arr4){
			result = result.concat(arr4);
		}
		if(arr5){
			result = result.concat(arr5);
		}
		
		return result;
	}
	
	function isElementOnLeft(element1, element2){
		if(element1.getBoundingClientRect().left < element2.getBoundingClientRect().left){
			return true;
		}
		return false;
	}
	

	function findDatePattern(tokens){
		var datePattern = {}, token;
		for(var i=0; i<tokens.length; i++){
			token = tokens[i];
			if(token.indexOf('mm/dd/yyyy')>-1){
				datePattern.pattern = 'mm/dd/yyyy';
			} else if(token.indexOf('mm/dd/yy')>-1){
				datePattern.pattern = 'mm/dd/yy';
			} else if(token.indexOf('mm-dd-yyyy')>-1){
				datePattern.pattern = 'mm-dd-yyyy';
			}  else if(token.indexOf('mm-dd-yy')>-1){
				datePattern.pattern = 'mm-dd-yy';
			} else if(token.indexOf('dd/mm/yyyy')>-1){
				datePattern.pattern = 'dd/mm/yyyy';
			} else if(token.indexOf('dd/mm/yy')>-1){
				datePattern.pattern = 'dd/mm/yy';
			} else if(token.indexOf('dd-mm-yyyy')>-1){
				datePattern.pattern = 'dd-mm-yyyy';
			} else if(token.indexOf('dd-mm-yy')>-1){
				datePattern.pattern = 'dd-mm-yy';
			} else if(token.indexOf('yyyy/mm/dd')>-1){
				datePattern.pattern = 'yyyy/mm/dd';
			} else if(token.indexOf('yy/mm/dd')>-1){
				datePattern.pattern = 'yy/mm/dd';
			} else if(token.indexOf('yyyy-mm-dd')>-1){
				datePattern.pattern = 'yyyy-mm-dd';
			} else if(token.indexOf('yy-mm-dd')>-1){
				datePattern.pattern = 'yy-mm-dd';
			} 
			
			if(datePattern.pattern != ''){
				datePattern.elementOrder = [];
				if(datePattern.pattern != 'mm/dd/yyyy' || datePattern.pattern != 'mm/dd/yy' 
					|| datePattern.pattern != 'mm-dd-yyyy' || datePattern.pattern != 'mm-dd-yy'){
					datePattern.elementOrder.push(WAXJS.IdentityFieldTypes.DobMonthField);
					datePattern.elementOrder.push(WAXJS.IdentityFieldTypes.DobDayField);
					datePattern.elementOrder.push(WAXJS.IdentityFieldTypes.DobYearField);
				} else if(datePattern.pattern != 'dd/mm/yyyy' || datePattern.pattern != 'dd/mm/yy' 
					|| datePattern.pattern != 'dd-mm-yyyy' || datePattern.pattern != 'dd-mm-yy'){
					datePattern.elementOrder.push(WAXJS.IdentityFieldTypes.DobDayField);
					datePattern.elementOrder.push(WAXJS.IdentityFieldTypes.DobMonthField);
					datePattern.elementOrder.push(WAXJS.IdentityFieldTypes.DobYearField);
				} else if(datePattern.pattern != 'yyyy/mm/dd' || datePattern.pattern != 'yy/mm/dd' 
					|| datePattern.pattern != 'yyyy-mm-dd' || datePattern.pattern != 'yy-mm-dd'){
					datePattern.elementOrder.push(WAXJS.IdentityFieldTypes.DobYearField);
					datePattern.elementOrder.push(WAXJS.IdentityFieldTypes.DobMonthField);
					datePattern.elementOrder.push(WAXJS.IdentityFieldTypes.DobDayField);
				}
				return datePattern;
			}
		}
		return null;
    }
	

	/* This method will check whether this field can be a potential group field */
	/* The check will be done only on fields with alteast one individual label token */
	function getPossibleGroup(inputElement){
		if(inputElement.htmlElement.tagName.toLowerCase()=='select'){
			if(WAXJS.Util.isMonthField(inputElement)){
				return WAXJS.GenericGroupTypes.DateGroup;
			} else if(WAXJS.Util.isDayField(inputElement)){
				return WAXJS.GenericGroupTypes.DateGroup;
			} else if(WAXJS.Util.isYearField(inputElement)){
				return WAXJS.GenericGroupTypes.DateGroup;
			}
		}
		
		if(!inputElement.labelTokens || !inputElement.labelTokens.length){
			return;
		}
		
		var token;
		for(var i=0; i<inputElement.labelTokens.length; i++){
			token = inputElement.labelTokens[i];
			if(isPossibleDateGroupField(token)){
				return WAXJS.GenericGroupTypes.DateGroup;
			} else if(isPossiblePhoneGroupField(token)){
				return WAXJS.GenericGroupTypes.PhoneGroup;
			} else if(isPossibleNameGroupField(token)){
				return WAXJS.GenericGroupTypes.FullNameGroup;
			} 
		}
	}
	
	function isPossibleDateGroupField(token){
		var index = isWaxField2(token, WAXJS.LabelTokens.BIRTHDAY_MONTH);
		if(index >= 0){
			return true;
		}
		
		index = isWaxField2(token, WAXJS.LabelTokens.BIRTHDAY_DAY);
		if(index >= 0){
			return true;
		}
		
		index = isWaxField2(token, WAXJS.LabelTokens.BIRTHDAY_YEAR);
		if(index >= 0){
			return true;
		}
	}
	
	function isPossiblePhoneGroupField(token){
		var index = isWaxField2(token, WAXJS.LabelTokens.PHONE_GROUP_ISD_CODE);
		if(index >= 0){
			return true;
		}
		
		index = isWaxField2(token, WAXJS.LabelTokens.PHONE_GROUP_NUMBER);
		if(index >= 0){
			return true;
		}
	}
	
	function isPossibleNameGroupField(token){
		var index = isWaxField2(token, WAXJS.LabelTokens.FULLNAME_GROUP_MEMBER_TOKENS);
		if(index >= 0){
			return true;
		}
	}
	
	function isFormAnalyzed(form){
		var analyzedForm;
		if(!WAXJS.analyzedForms || !WAXJS.analyzedForms.length){
			return false;
		}
		
		for(var i=0; i<WAXJS.analyzedForms.length; i++){
			analyzedForm = WAXJS.analyzedForms[i];
			if(analyzedForm.htmlElement == form){
				return true;
			}
		}		
		return false;
	}
	
	function isFrameAccessible(frame){
		var documentUrl, frameUrl;
		
		try{
			if(!frame.src){
				return true;
			}
			
			documentUrl = getUrlParts(window.location.href);
			frameUrl = getUrlParts(frame.src);
			
			/* Frame will be accessible only when protocol, domain and port matches */
			if(documentUrl.protocol != frameUrl.protocol){
				return false;
			}
			if(documentUrl.hostname != frameUrl.hostname){
				return false;
			}
			if(documentUrl.port != frameUrl.port){
				return false;
			}
			return true;
		}catch(e){}
		return false;
	}
	
	function isArray(obj) {
		return Object.prototype.toString.call(obj) === '[object Array]'; 
	}
	
    return {
        addStyle: addStyle,
        getUniqueKey: getUniqueKey,
        findPos: findPos,
        fillEl: fillEl,
        fillDate: fillDate,
        concatArrays: concatArrays,
        getUrlParts : getUrlParts,
		isFillableElement: isFillableElement,
		isUserIdField: isUserIdField,
		isUserIdField2: isUserIdField2,
		isPasswordField: isPasswordField,
		isPasswordField2: isPasswordField2,
		isFirstNameField: isFirstNameField,
		isLastNameField: isLastNameField,
		isTitleField: isTitleField,
		isVisible: isVisible,
		isSubmitElement: isSubmitElement,
		isElementInside: isElementInside,
		containsNode: containsNode,
		populateWebPageData: populateWebPageData,
		isMiddleNameField: isMiddleNameField,
		isUserNameField: isUserNameField,
		isFullNameField: isFullNameField,
		isEmailAddressField: isEmailAddressField,
		isAddressLine1Field: isAddressLine1Field,
		isAddressLine2Field: isAddressLine2Field,
		isAddressLine3Field: isAddressLine3Field,
		isFullAddressField: isFullAddressField,
		isCityNameField: isCityNameField,
		isStateNameField: isStateNameField,
		isCountryNameField: isCountryNameField,
		isCountryNameField2: isCountryNameField2,
		isZipCodeField: isZipCodeField,
		isHomePhoneField: isHomePhoneField,
		isMobilePhoneField: isMobilePhoneField,
		isWorkPhoneField: isWorkPhoneField,
		isGenericPhoneField: isGenericPhoneField,
		isGenderField: isGenderField,
		isGenderFieldMale: isGenderFieldMale,
		isGenderFieldFemale: isGenderFieldFemale,
		fillGender: fillGender,
		fillTitle: fillTitle,
		isAnyDateField: isAnyDateField,
		isBirthdayField: isBirthdayField,
		isMonthField: isMonthField,
		isDayField: isDayField,
		isYearField: isYearField,
		cleanupTokens: cleanupTokens,
		cleanupToken: cleanupToken,
		isWaxField2: isWaxField2,
		isElementOnLeft: isElementOnLeft,
		findDatePattern: findDatePattern,
		getPossibleGroup: getPossibleGroup,
		isFormAnalyzed: isFormAnalyzed,
		isFrameAccessible: isFrameAccessible,
		isArray: isArray};
})();


WAXJS.Events = (function() {
    var cache = {};

    function publish(eventName, args) {        
        try {
            cache[eventName].forEach(function(item, i, arr) {
                var args_new = [];
                if(args){
					args_new.push(args);
				}
                
                args_new = (item.extra_args) ? args_new.concat(item.extra_args) : args_new;
                try {
                    item.callback.apply(window, args_new);
                } catch (e) { }
            });                
        } catch (e) { }
    }

    function subscribe(eventName, callback, extra_args) {       
        if (!cache[eventName]) {
            cache[eventName] = [];
        }
		
		var callbackExists = false;
		cache[eventName].forEach(function(item,i, arr){
			if(callback == item.callback){
				callbackExists = true;
				return;
			}
		});
		
		if(!callbackExists){
			cache[eventName].push({callback: callback, extra_args: extra_args});
		}
    }

    function unsubscribe(eventName, callback) {
        if(!cache[eventName]){
			return;
		}
		
		cache[eventName].forEach(function(item, i, arr){
			if(item.callback==callback){
				arr.splice(i,1);
				return;
			}
		});
    }
    
    return {
        publish: publish,
        subscribe: subscribe,
        unsubscribe: unsubscribe
    }
})();      
